/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: if_tu_data.c,v $
 * Revision 1.1.13.7  1995/11/15  14:42:37  Rajul_Shah
 * 	Add a counter for keeping track of reque'd exessive collisions.
 * 	[1995/11/14  16:06:46  Rajul_Shah]
 *
 * Revision 1.1.13.6  1995/10/26  17:54:32  Rajul_Shah
 * 	Add a counter for keeping track of actual collisions.
 * 	[1995/10/26  17:22:01  Rajul_Shah]
 * 
 * Revision 1.1.13.5  1995/09/22  20:19:23  Rajul_Shah
 * 	Add some flags and variables to support auto programming
 * 	of transmit FIFO threshold.
 * 	[1995/09/21  19:42:39  Rajul_Shah]
 * 
 * Revision 1.1.13.4  1995/05/23  21:55:27  Rajul_Shah
 * 	Merge of Platinum Lite BL4 changes.
 * 	[1995/05/23  21:55:03  Rajul_Shah]
 * 
 * Revision 1.1.24.2  1995/03/27  18:39:06  Rajul_Shah
 * 	Merge of revision 1.1.22.2 from HW4 BL3 plus changes
 * 	for supporting the de500.
 * 	[1995/03/27  18:34:30  Rajul_Shah]
 * 
 * Revision 1.1.22.2  1995/03/09  20:59:48  Rajul_Shah
 * 	Added 'tu_cfda' io-handle and various mode flags within
 * 	the softc to support software selection of the 10Base2
 * 	and 10Base5 ports. Also added 'tu_port_selection'.
 * 	[1995/03/09  18:08:46  Rajul_Shah]
 * 
 * Revision 1.1.13.3  1994/12/08  21:21:19  Karl_Ebner
 * 	merge of Gold Minor BL4 changes
 * 	[1994/12/08  21:07:43  Karl_Ebner]
 * 
 * Revision 1.1.13.2  1994/11/08  17:25:01  Andrew_Duane
 * 	Correction to merge of revision 1.1.8.2
 * 	[1994/09/22  16:37:11  Andrew_Duane]
 * 
 * 	Moved include of "tu.h" inside !BINARY
 * 	[1994/09/21  20:46:20  Andrew_Duane]
 * 
 * Revision 1.1.12.4  1994/11/18  18:42:52  Rajul_Shah
 * 	Add a field in the softc for saving reference to the
 * 	special setup-frame buffer allocated in tuprobe().
 * 	[1994/11/15  13:58:38  Rajul_Shah]
 * 
 * Revision 1.1.12.3  1994/11/10  23:03:25  Rajul_Shah
 * 	Merge changes from HW3-BL6.
 * 	[1994/11/10  21:46:25  Rajul_Shah]
 * 
 * Revision 1.1.10.2  1994/10/05  15:49:54  Rajul_Shah
 * 	Eliminated definitions of tu_cflt_val & tu_cfcs_val: these
 * 	are no longer needed.
 * 	[1994/10/03  20:44:50  Rajul_Shah]
 * 
 * Revision 1.1.12.2  1994/11/04  21:21:38  Rajul_Shah
 * 	Added flag in softc for fast/slow speed (used when
 * 	device is DECchip 21140: Fast Ethernet).
 * 	[1994/11/02  20:50:38  Rajul_Shah]
 * 
 * Revision 1.1.5.5  1994/04/19  21:55:03  Stuart_Hollander
 * 	merge agoshw2 bl5 to gold
 * 	Revision 1.1.2.8  1994/04/15  19:42:29  Rajul_Shah
 * 	Deleted flags that are no longer used.
 * 	[1994/04/13  21:38:37  Rajul_Shah]
 * 
 * Revision 1.1.5.4  1994/03/28  01:44:35  Tim_Hoskins
 * 	convert rcsid to pragma ident
 * 	[1994/03/28  01:36:55  Tim_Hoskins]
 * 
 * Revision 1.1.5.3  1994/02/25  21:18:53  Stuart_Hollander
 * 	merge agoshw2 bl3 to gold
 * 	[1994/02/23  15:44:53  Stuart_Hollander]
 * 
 * Revision 1.1.2.7  1994/02/21  22:38:46  Rajul_Shah
 * 	Turned on definition of handler-id (ifdef taken out).
 * 	[1994/02/16  21:55:55  Rajul_Shah]
 * 
 * Revision 1.1.2.6  1994/02/02  17:43:17  Donald_Dutile
 * 	ifdef'd code in when handler_add avail for EISA as well as PCI.
 * 	[1994/01/27  22:33:49  Donald_Dutile]
 * 
 * Revision 1.1.2.5  1994/01/26  14:44:58  Rajul_Shah
 * 	Eliminated the tu_setup_cmd struct and related elements
 * 	from softc --- these are no longer used.
 * 	[1994/01/24  04:33:23  Rajul_Shah]
 * 
 * Revision 1.1.2.4  1994/01/07  17:13:10  Rajul_Shah
 * 	Added a couple of elements in softc to save away values
 * 	of the PCI Latency-Timer and Command-Status registers.
 * 	Also some minor comment cleanup (physaddr -> io-handle).
 * 	[1993/12/30  19:27:18  Rajul_Shah]
 * 
 * Revision 1.1.2.3  1993/12/28  21:34:50  Rajul_Shah
 * 	Added flags field to support the auto-sense logic. And also
 * 	added a 6-byte array to save away the Rom Ethernet Id.
 * 	[1993/12/23  21:10:41  Rajul_Shah]
 * 
 * Revision 1.1.2.2  1993/12/17  22:03:37  Rajul_Shah
 * 	Data file for the Tulip Ethernet driver - initial version.
 * 	[1993/12/16  21:04:39  Rajul_Shah]
 * 
 * $EndLog$
 */
/*
#pragma ident "@(#)$RCSfile: if_tu_data.c,v $ $Revision: 1.1.13.7 $ (DEC) $Date: 1995/11/15 14:42:37 $"
*/

#include <sys/param.h>
#include <sys/systm.h>
#include <sys/mbuf.h>
#include <sys/buf.h>
#include <sys/protosw.h>
#include <sys/socket.h>
#include <sys/vmmac.h>
#include <vm/vm_kern.h>
#include <sys/ioctl.h>
#include <sys/errno.h>
#include <sys/time.h>
#include <sys/kernel.h>
#include <sys/proc.h>  /* Needed for nonsymmetric drivers. us */

#include <net/if.h>
#include <net/netisr.h>
#include <net/route.h> 
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/in_var.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/if_ether.h>
#include <net/ether_driver.h>
#include <io/common/devdriver.h>
#include <hal/cpuconf.h>
#include <io/dec/eisa/eisa.h>
#include <io/dec/pci/pci.h>
#include <io/dec/netif/if_simreg.h>

/*
 * Each interface is referenced by a network interface structure,
 * is_if, which the routing code uses to locate the interface.
 */
#define	is_if	is_ac.ac_if		/* network-visible interface 	*/
#define	is_addr	is_ac.ac_enaddr		/* hardware Ethernet address 	*/


/*
 * Definitions for Multicast and setup frames
 */
#define SE_PMULTI	14		/* Max perfect multicast addresses */
#define SE_NMULTI	512		/* Max hashed multi-cast addresses */

#define SE_SETUP_SIZE 	192		/* Size of Setup Frame 		*/

struct se_multi {
	u_char	se_multi_char[6];
};

struct se_setup {
	u_char  se_setup_char[12];
};


struct	se_softc {
	struct  ether_driver is_ed;	/* Ethernet driver common part 	*/
#define is_ac   is_ed.ess_ac    	/* Ethernet common part         */
#define ctrblk  is_ed.ess_ctrblk	/* Counter block	        */
#define ztime   is_ed.ess_ztime         /* Time counters last zeroed    */
	u_long	rring_phys;		/* Receive ring desc. phys addr */
	u_long	tring_phys;		/* Transmit ring desc. phys addr*/
	struct se_setup *setup_bufr;	/* Buffer for setup-frame	*/
	int	ntinuse;		/* Transmit descriptors in use 	*/
	int	ntpendg;		/* Transmits pending in the ring*/
	int	itindex;		/* Next input transmit index	*/
	int	otindex;		/* Next output Transmit index	*/
	int	rindex;			/* Next in/out Receive index	*/
	int	se_sysid_type;		/* TULIP SysId Type (EISA/PCI)	*/
	u_int	se_revision;		/* TULIP Revision number  	*/
	u_int	se_vendor_id;		/* TULIP Vendor-ID (DEC)	*/
	u_int	se_device_id;		/* TULIP Device-ID (Tulip!)	*/
	u_long  se_csr_base;		/* TULIP CSR base value		*/
	u_long	se_csr[16];		/* TULIP CSRs 0..15 io-handles	*/
	u_long	se_cfid;		/* TULIP Conf Id Reg io-handle	*/
	u_long	se_cfcs;		/* TULIP Conf Cmd/Stat io-handle*/
	u_long	se_cfrv;		/* TULIP Conf Rev Reg io-handle	*/
	u_long	se_cflt;		/* TULIP Conf Latency io-handle	*/
	u_long	se_cbio;		/* TULIP Conf BaseIO io-handle	*/
	u_long	se_cfda;		/* TULIP Conf DrvArea io-handle	*/
	struct {
		u_int aui_mode: 1;	/* Set if AUI-10Base5 selected 	*/
		u_int bnc_mode: 1;	/* Set if BNC-10Base2 selected 	*/
		u_int fast_speed: 1;	/* Set if speed = 100 Mb/sec 	*/
		u_int full_duplex: 1;	/* Set if Full-Duplex Enabled 	*/
		u_int ce_resolve: 1;	/* Set if Capture Effect enabled*/
		u_int auto_tr: 1;	/* Set if Tx Threshold in auto mode */
		u_int sf_mode: 1;	/* Set if Tx Store-Forward mode is on */
	} se_flags;
	u_int	se_tr;			/* Tx Threshold value selected	*/
	u_int	actual_ccount;		/* Actual collision count	*/
	u_int	ec_reque_count;		/* # of Exessive collisions reque'd */
	char 	se_port_selection[80];	/* Set by media sensing routine */
	u_char	se_rom_addr[6];		/* Enet ROM Address saved here	*/
	simple_lock_data_t lk_se_softc; /* SMP lock for se_softc        */
	struct	se_multi is_multi[SE_NMULTI]; /* Multicast address list	*/
	u_char	is_muse[SE_NMULTI];	/* Multicast address reference count */
	u_int	is_nmulti;		/* Number of active Multicasts */
	ihandler_id_t	*hid;		/* ihander_id_t rtn from handler_add */
        struct IfsimState ifsimState; 	/* has all the info for simether */
};

#ifdef BINARY
extern	struct	se_softc se_softc[];
extern	struct	controller *seinfo[];
#else

#include "simether.h"

struct	se_softc  se_softc[NSIMETHER];
struct	controller *seinfo[NSIMETHER];
#endif
