/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: pci_option_data.c,v $
 * Revision 1.1.96.9  1997/09/02  13:35:14  Janet_Schank
 * 	 	** Merge Information **
 * 		** Command used:	bmerge -rPTCOS;PTHW1OS_BL3;<> **
 * 		** Ancestor revision:	1.1.96.6 **
 * 		** Merge revision:	1.1.96.8 **
 * 	 	** End **
 * 	[1997/09/01  23:09:45  Janet_Schank]
 *
 * 	Added USB OpenHCI entry.
 * 	[1997/09/01  23:02:42  Janet_Schank]
 *
 * Revision 1.1.96.8  1997/08/28  16:25:11  Julie_Dewandel
 * 	 	** Merge Information **
 * 		** Command used:	bsubmit **
 * 		** Ancestor revision:	1.1.96.6 **
 * 		** Merge revision:	1.1.96.7 **
 * 	 	** End **
 * 	Added support for PCI Meteor (ATM) adapter
 * 	[1997/08/26  20:14:03  Julie_Dewandel]
 * 
 * Revision 1.1.96.7  1997/08/27  20:40:34  William_Evers
 * 	 	** Merge Information **
 * 		** Command used:	bmerge **
 * 		** Ancestor revision:	1.1.99.3 **
 * 		** Merge revision:	1.1.96.6 **
 * 	 	** End **
 * 	[1997/08/26  18:15:23  William_Evers]
 * 
 * 	add support for generic isa bridge.  This will enable
 * 	the cy83c693u isa bridge chip.  Also add support for
 * 	cy83c693u ide.
 * 	[1997/07/10  17:48:19  William_Evers]
 * 
 * Revision 1.1.96.6  1997/06/10  19:58:07  Thomas_Blinn
 * 	Fix QAR 53371 (PTM07738)
 * 	Add entry for CYPRESS_82C693 ISA bridge and ATA controller.
 * 	[1997/06/06  14:52:04  Thomas_Blinn]
 * 
 * Revision 1.1.96.5  1997/05/07  19:44:41  William_Evers
 * 	 	** Merge Information **
 * 		** Command used:	bmerge **
 * 		** Ancestor revision:	1.1.96.3 **
 * 		** Merge revision:	1.1.96.4 **
 * 	 	** End **
 * 	[1997/05/07  19:11:39  William_Evers]
 * 
 * 	add support for generic isa bridge.  This will enable
 * 	the cy83c693u isa bridge chip.
 * 	[1997/05/06  18:27:40  William_Evers]
 * 
 * Revision 1.1.96.4  1997/04/17  20:18:20  Fred_Knight
 * 	 	** Merge Information **
 * 		** Command used:	bmerge -jPTBOS_BL4:PTHW1OS_BL3 **
 * 		** Ancestor revision:	1.1.91.2 **
 * 		** Merge revision:	1.1.99.3 **
 * 	 	** End **
 * 	[1997/04/17  19:42:22  Fred_Knight]
 * 
 * Revision 1.1.96.3  1997/01/24  22:10:55  Rajul_Shah
 * 	Added entry for DECchip 21142 (latest 10/100 Fast Ethernet chip).
 * 	Also went ahead and changed DEC_PACER to DEC_DEFPA (PCI-FDDI).
 * 	[1997/01/22  20:30:50  Rajul_Shah]
 * 
 * Revision 1.1.99.3  1997/01/10  00:15:37  Fred_Knight
 * 	Add several PCI ATA/EIDE adapters.
 * 	[1997/01/09  21:27:09  Fred_Knight]
 * 
 * Revision 1.1.99.2  1997/01/08  20:42:31  Rajul_Shah
 * 	Added entry for DECchip 21142 (latest 10/100 Fast Ethernet chip).
 * 	[1997/01/06  21:40:50  Rajul_Shah]
 * 
 * Revision 1.1.96.2  1996/11/21  23:29:10  Jim_Hamel
 * 	remove reference to rmspur driver
 * 	[1996/11/20  23:04:38  Jim_Hamel]
 * 
 * Revision 1.1.91.2  1996/09/05  19:13:26  Thomas_Blinn
 * 	 	** Merge Information **
 * 		** Command used:	bmerge -rTADPOLE **
 * 		** Ancestor revision:	1.1.82.2 **
 * 		** Merge revision:	1.1.87.4 **
 * 	 	** End **
 * 	propagating tadpole
 * 	[1996/08/31  14:27:15  Thomas_Blinn]
 * 
 * Revision 1.1.87.4  1996/06/04  18:12:04  Peter_Woods
 * 	Include pcmcia.h file.
 * 	[1996/06/04  13:44:51  Peter_Woods]
 * 
 * Revision 1.1.87.3  1996/06/03  16:28:54  Peter_Woods
 * 	Stub off pd6729_conf() function on systems that have no
 * 	PCMCIA support
 * 	[1996/06/03  16:27:32  Peter_Woods]
 * 
 * Revision 1.1.87.2  1996/05/30  17:42:32  Peter_Woods
 * 	Added entry for PD6729 PC Card adapter
 * 	[1996/05/30  17:41:10  Peter_Woods]
 * 
 * Revision 1.1.82.2  1996/04/12  14:58:21  James_Smart
 * 	{** Merge Information **}
 * 		{** Command used:	bmerge -jPTLITEOS_BL6:HW6OS_BL4 **}
 * 		{** Ancestor revision:	1.1.50.7 **}
 * 		{** Merge revision:	1.1.77.3 **}
 * 	{** End **}
 * 	HW6 to PTHW1 merge
 * 	[1996/04/12  14:15:08  James_Smart]
 * 
 * Revision 1.1.77.3  1996/03/06  20:04:38  David_Partridge
 * 	Add entry for TGA2 graphics option.
 * 	[1996/03/05  19:52:19  David_Partridge]
 * 
 * Revision 1.1.77.2  1996/02/27  20:24:48  James_Smart
 * 	Add recognition for NCR/Symbios 825/860/875 chips.
 * 	[1996/02/23  21:25:51  James_Smart]
 * 
 * Revision 1.1.55.10  1996/02/01  14:06:25  Paul_Grist
 * 	remove identification of unsupported grapics to allow generic vga use
 * 	[1996/01/24  18:52:55  Paul_Grist]
 * 
 * Revision 1.1.55.9  1995/11/15  19:49:54  Dave_Gerson
 * 	Split S3 Trio entries - Trio32 vs Trio64
 * 	[1995/11/15  00:01:17  Dave_Gerson]
 * 
 * Revision 1.1.55.8  1995/10/25  19:58:33  Kirt_Gillum
 * 	Add references for PCI Token Ring implementations.
 * 	[1995/10/18  19:40:33  Kirt_Gillum]
 * 
 * Revision 1.1.55.7  1995/10/19  20:10:36  Karl_Ebner
 * 	Backed out Revision 1.1.67.2
 * 	[1995/10/19  20:00:17  Karl_Ebner]
 * 
 * 	Option data for controllers is moved to sysconfigtab.
 * 	[1995/10/18  17:19:19  Karl_Ebner]
 * 
 * Revision 1.1.55.6  1995/10/19  11:49:19  Karl_Ebner
 * 	Option data for controllers is moved to sysconfigtab.
 * 	[1995/10/18  17:19:19  Karl_Ebner]
 * 
 * Revision 1.1.62.4  1995/09/22  17:51:07  James_Smart
 * 	Back out automatic NCR 825 recognition.
 * 	[1995/09/21  19:11:04  James_Smart]
 * 
 * Revision 1.1.62.3  1995/09/08  18:29:51  James_Smart
 * 	Add recognition of the NCR 825 card.
 * 	[1995/09/07  14:57:10  James_Smart]
 * 
 * Revision 1.1.55.5  1995/08/22  22:40:27  Paul_Grist
 * 	vga driver restructuring
 * 	[1995/08/22  22:32:48  Paul_Grist]
 * 
 * Revision 1.1.55.4  1995/08/21  17:22:08  Dale_Bloemen
 * 	Added TGA2 entry.
 * 	[1995/08/17  20:59:14  Dale_Bloemen]
 * 
 * Revision 1.1.62.2  1995/08/03  16:45:07  Kirt_Gillum
 * 	Add references for PCI Token Ring implementations.
 * 	[1995/08/02  21:00:38  Kirt_Gillum]
 * 
 * Revision 1.1.55.3  1995/05/23  14:49:33  Peter_Woods
 * 	merge of Platinum Lite BL4 changes
 * 	[1995/05/23  13:50:37  Peter_Woods]
 * 
 * Revision 1.1.50.7  1995/04/21  16:58:40  Sam_Hsu
 * 	Add entry for PV graphics controller.
 * 	[1995/04/19  22:30:15  Sam_Hsu]
 * 
 * Revision 1.1.50.6  1995/04/13  21:01:25  Carol_Sheridan
 * 	Added entry for ATI Mach64 CT graphics controller.
 * 	[1995/04/06  21:20:34  Carol_Sheridan]
 * 
 * Revision 1.1.55.2  1995/04/06  22:42:12  Dave_Gerson
 * 	Added entry for S3 Trio32/64 graphics adapter.
 * 	[1995/04/06  22:41:09  Dave_Gerson]
 * 
 * Revision 1.1.50.5  1995/03/27  18:53:42  Rajul_Shah
 * 	Added entries for the new DECchip 21041 (Pass 3 Tulip) and
 * 	also for the PCI-ATM/OTTO (oppo) module from SRC.
 * 	[1995/03/22  21:53:30  Rajul_Shah]
 * 
 * Revision 1.1.50.4  1995/03/22  16:42:26  James_Smart
 * 	Add entry for NCR_810A
 * 	[1995/03/14  14:00:07  James_Smart]
 * 
 * Revision 1.1.50.3  1995/03/20  19:39:15  Dave_Gerson
 * 	Added entry for S3 Trio32/64 graphics adapter.
 * 	[1995/03/10  17:37:54  Dave_Gerson]
 * 
 * Revision 1.1.50.2  1995/02/27  21:58:15  Donald_Dutile
 * 	Fix "Future DEC PPB" did_mo_flag from 1 to 0.
 * 	[1995/02/27  14:46:20  Donald_Dutile]
 * 
 * 	Update to V2.1 of PCI: add Subsystem VID & DID fields
 * 	[1995/02/22  21:09:48  Donald_Dutile]
 * 
 * Revision 1.1.43.6  1994/11/10  21:13:57  Donald_Dutile
 * 	Merge from HW3OS.BL6:
 * 	  Revision 1.1.30.7  1994/10/21  19:53:34  Jay_Estabrook
 * 	  Add entry for ATI Mach64 CX controller.
 * 	  [1994/10/21  19:51:01  Jay_Estabrook]
 * 	[1994/11/08  16:17:29  Donald_Dutile]
 * 
 * Revision 1.1.43.5  1994/11/04  21:21:39  Rajul_Shah
 * 	Added entry for DECchip 21140 (FasterNET fast ethernet)
 * 	and also changed DEC_TULIP to DEC_21040 for consistency.
 * 	[1994/10/24  20:48:34  Rajul_Shah]
 * 
 * Revision 1.1.43.4  1994/10/13  18:37:49  William_Grava
 * 	Reflective Memory (RM)
 * 	[1994/10/13  17:55:40  William_Grava]
 * 
 * Revision 1.1.43.3  1994/09/23  16:55:58  Chau_Tseng
 * 	merge of Hardware BL4 changes
 * 	[1994/09/23  15:24:05  Chau_Tseng]
 * 
 * Revision 1.1.43.2  1994/09/09  19:58:21  Rajul_Shah
 * 	Added entry for PCI-FDDI (PACER/DEFPA). Also changed
 * 	DEC_4250 to DEC_TULIP.
 * 	[1994/09/01  13:02:56  Rajul_Shah]
 * 
 * Revision 1.1.30.6  1994/08/26  20:30:28  Jay_Estabrook
 * 	Add entry for S3 Vision864 PCI VGA controller.
 * 	[1994/08/26  19:16:55  Jay_Estabrook]
 * 
 * Revision 1.1.30.5  1994/08/01  17:42:14  Jay_Estabrook
 * 	Add entry for COMPAQ ARIEL PCI VGA controller.
 * 	[1994/08/01  14:41:38  Jay_Estabrook]
 * 
 * Revision 1.1.30.4  1994/07/29  21:41:01  Cheryl_Deleo
 * 	Added Mylex RAID controller option "xcr".
 * 	[1994/07/29  20:33:43  Cheryl_Deleo]
 * 
 * Revision 1.1.30.3  1994/07/29  13:12:23  Ali_Rafieymehr
 * 	Changed the driver name for the pci nvram from nvpci to pnvram
 * 	to match the eisa nvram.
 * 	[1994/07/27  19:32:12  Ali_Rafieymehr]
 * 
 * Revision 1.1.30.2  1994/06/28  22:17:06  Bruce_Hansen
 * 	Add AXPVME64 PCI to VIC64 VME configuration information
 * 	[1994/06/23  16:47:59  Bruce_Hansen]
 * 
 * Revision 1.1.15.10  1994/05/31  18:19:24  Donald_Dutile
 * 	Update entries for extended config-hdr matching.
 * 	[1994/05/26  21:47:08  Donald_Dutile]
 * 
 * Revision 1.1.15.9  1994/05/10  21:25:58  Donald_Dutile
 * 	Added PPB i.d.; reorg'd entries for quicker match.
 * 	Added QLOGIC ISP1020.
 * 	Eliminated Adaptec 7870; re-org'd list for faster match.
 * 	[1994/05/05  19:04:37  Donald_Dutile]
 * 
 * Revision 1.1.15.8  1994/04/19  18:57:29  William_Burns
 * 	Fix bad merge.
 * 	[1994/04/18  17:52:26  William_Burns]
 * 
 * Revision 1.1.15.7  1994/04/11  14:10:56  William_Burns
 * 	merge agoshw2.bl4 to gold.
 * 	[1994/04/05  14:00:22  William_Burns]
 * 
 * Revision 1.1.15.6  1994/04/10  17:29:53  Karl_Ebner
 * 	Vendor and Device ID definitions moved to pci.h
 * 	[1994/04/06  21:56:32  Karl_Ebner]
 * 
 * Revision 1.1.15.5  1994/03/29  21:48:11  Janet_Schank
 * 	Added PZA support.
 * 	[1994/03/21  13:56:44  Janet_Schank]
 * 
 * Revision 1.1.15.4  1994/03/28  02:02:07  Tim_Hoskins
 * 	convert rcsid to pragma ident
 * 	[1994/03/28  01:53:55  Tim_Hoskins]
 * 
 * Revision 1.1.5.7  1994/03/18  17:41:09  Donald_Dutile
 * 	Changed informational printf's in pcebconf and sioconf
 * 	    routines to be conditionally compiled in.
 * 	Removed intr_b4_probe, itr_aft_attach -- handler_*()
 * 	    performs these operations by device-specific drivers.
 * 	[1994/03/17  14:26:17  Donald_Dutile]
 * 
 * Revision 1.1.5.6  1994/03/07  17:12:22  Donald_Dutile
 * 	Set itr_aft attach to 0 for eisa & isa bridge.
 * 	Temp fix until adapter-specific code zero's intr_mask field
 * 	for the respective PCI config hdr structures.
 * 	[1994/03/03  20:09:10  Donald_Dutile]
 * 
 * Revision 1.1.15.3  1994/03/03  00:12:47  Mike_MacKay
 * 	changed eisa  'intr after attach' from 1 to 0
 * 	changed psiop from controller (C) to adapter (A)
 * 	[1994/03/01  01:12:59  Mike_MacKay]
 * 
 * 	Changed the PSIOP entry from a controller typr to an adaptor type.
 * 	[1994/02/25  20:00:25  Mike_MacKay]
 * 
 * Revision 1.1.15.2  1994/01/23  21:10:09  Stuart_Hollander
 * 	Merge from agoshw2 bl2 to goldbl8
 * 	[1994/01/12  20:14:38  Stuart_Hollander]
 * 
 * Revision 1.1.5.5  1994/01/06  20:07:08  John_Gallant
 * 	Uncommented the psiop line to enable the 810 in PCI configuration.
 * 	[1994/01/06  15:42:42  John_Gallant]
 * 
 * Revision 1.1.5.4  1994/01/03  21:58:17  Mark_Parenti
 * 	Merge to pool.
 * 	[1993/12/22  18:55:51  Mark_Parenti]
 * 
 * 	Add comments to describe format mkdata requires.
 * 	[1993/12/21  21:13:54  Mark_Parenti]
 * 
 * Revision 1.1.5.3  1993/12/21  13:42:07  Monty_Brandenberg
 * 	Add TGA graphics device to list of known devices.
 * 	[1993/12/14  00:19:39  Monty_Brandenberg]
 * 
 * Revision 1.1.5.2  1993/10/26  21:12:00  Donald_Dutile
 * 	Enable id-ing of PCI-ATI card for pci config code;
 * 	fix nosioconf define.
 * 	[1993/10/26  20:33:28  Donald_Dutile]
 * 
 * 	First cut for PCI bus config debug on MORGAN.
 * 	[1993/09/03  20:17:21  Donald_Dutile]
 * 
 * $EndLog$
 */
#pragma ident "@(#)$RCSfile: pci_option_data.c,v $ $Revision: 1.1.96.9 $ (DEC) $Date: 1997/09/02 13:35:14 $"

/* 
 * derived from tc_option_data.c	2.2      (ULTRIX)  3/2/90;
 */

/***************************************************************************/
/*                                                                         */
/* MODULE NAME: pci_option_data.c					   */
/* 									   */ 
/* LOCATION:	.../src/kernel/data					   */
/* 									   */ 
/* DESCRIPTION:								   */
/*		Contains data table for PCI bus options. This table maps   */
/*		option board vendor & device id name with device or        */
/*		controller name in the config file. The pci_option         */
/*		structure is defined in io/dec/pci/pci.h.		   */
/* 									   */ 
/***************************************************************************/


#include <io/dec/pci/pci.h>
#include <io/dec/pci/pci_debug.h>

extern int decppbconf();

int
nosioconf()
{
	PCIPRINTF(PCID_CNFG_SLOT, ("pci-isa/sio bridge conf code called.\n"));
}

int
nopcebconf()
{
	PCIPRINTF(PCID_CNFG_SLOT, ("pci-eisa/pceb bridge conf code called.\n"));
}


#include "isa.h"
#if NISA > 0
/* for now */
int	sioconf() 
{ 
    PCIPRINTF(PCID_CNFG_SLOT, ("sioconf placeholder \n")); 
}
#else
#define sioconf	nosioconf
#endif /* isa */


#include "eisa.h"
#if NEISA > 0
int	pcebconf() 
{ 
     PCIPRINTF(PCID_CNFG_SLOT, ("pcebconf placeholder \n")); 
}
#else
#define pcebconf nopcebconf
#endif /* eisa */

#include "vba.h"
#if NVBA > 0
extern int	ebv10_vmeconf();
#define vmeconf ebv10_vmeconf
#else
int
vmeconf()
{ 
     PCIPRINTF(PCID_CNFG_SLOT, ("vmeconf placeholder \n")); 
}
#endif /* vba */

#include "pcmcia.h"
#if NPCMCIA > 0
extern int
pd6729_conf();
#else
int
pd6729_conf()
{ 
     PCIPRINTF(PCID_CNFG_SLOT, ("pd6729_conf placeholder \n")); 
}
#endif 

/*
 * Dynamically added extern declarations
 * Note: If the struct pci_option line is changed you must modify
 * the mkdata utility as it keys on that line for placement of
 * dynamically added externs. The mkdata utility searches for the
 * string "option [" with a space between the "n" and the "[".
 */
/*
 * The eight (possible) PCI config header Device Identification
 * fields and a match-on flag (mo_flag) to indicate whether the
 * register should be used to match driver to device.
 */

struct pci_option pci_option [] =
{
 /*  SW	   vendor   device   rev     base     sub-     prog.    subsys   subsys  */
 /*  REV     id       id             class    class    i/f      vendor   device  */
 /*                                                               id       id    */
 /*  ---   -----    ----      ---    -----    -----    ----     ------   ------  */
 /*         vid      did     rev      base     sub      pif     sub-vid  sub-did */
 /*       mo_flag  mo_flag  mo_flag  mo_flag  mo_flag  mo_flag  mo_flag  mo_flag */
 /*  ---  -------  -------  -------  -------  -------  -------  -------  ------- */
 /* driver   type   adpt					                 */
 /*  name           config							 */

 /* DEC 21050 PPB */

 { 0x210, DEC_ID, DEC_21040,  0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "tu",   'C',     0},
 { 0x210, SIMOS_ID, SIMOS_ETHER,  0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "simether",   'C',     0},
  { 0x210, DEC_ID, DEC_21041,  0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "tu",   'C',     0},
 { 0x210, DEC_ID, DEC_21140,  0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "tu",   'C',     0},
 { 0x210, DEC_ID, DEC_21142,  0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "tu",   'C',     0},
 { 0x210, TI_ID, TI_TMS380,   0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "tra",  'C',     0},
 { 0x210, TCC_ID, TI_TMS380,  0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "tra",  'C',     0},
 { 0x210, DEC_ID, DEC_DEFPA,  0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "fta",  'C',     0},
 { 0x210, DEC_ID, DEC_DGLPB,  0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "lta",  'C',     0},
 { 0x210,TOSHIBA_ID,DEC_DGLPA,0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "lpa",  'C',     0},
 { 0x210, DEC_ID, DEC_TGA,    0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "tga",  'C',     0},
 { 0x210, DEC_ID, DEC_TGA2,    0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "tga",  'C',     0},
 { 0x210, DEC_ID, DEC_PVP,    0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "pvp",  'C',     0},
 { 0x210, DEC_ID, DEC_PZA,    0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "pza",  'A',     0},
 /* DEC 21050 PPB */
 { 0x210, DEC_ID, DEC_PPB,    0, BASE_BRIDGE, SUB_PCI,   0,      0,        0,
             1,      1,       0,       1,       1,       0,      0,        0,
    "pci",  'A',  decppbconf},
 /* Future DEC PPBs */
 { 0x210, DEC_ID,    0,       0, BASE_BRIDGE, SUB_PCI,   0,      0,        0,
             1,      0,       0,       1,       1,       0,      0,        0,
    "pci",  'A',  decppbconf},
 /* Third-party PPBs */
 { 0x210,    0,      0,       0, BASE_BRIDGE, SUB_PCI,   0,      0,        0,
             0,      0,       0,       1,       1,       0,      0,        0,
    "pci",  'A',  decppbconf},
 { 0x210,INTEL_ID,INTEL_PCEB, 0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "eisa", 'A',    pcebconf},
 { 0x210, INTEL_ID,INTEL_SIO, 0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "isa",  'A',    sioconf},
 { 0x210,    0,      0,       0, BASE_BRIDGE, SUB_ISA,   0,      0,        0,
             0,      0,       0,       1,       1,       0,      0,        0,
    "isa",  'A',    sioconf},
 { 0x210, DEC_ID, DEC_NVRAM,  0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
  "pnvram", 'C',     0},
 { 0x210, OLD_NCR_ID, NCR_810,0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
   "psiop", 'C',     0},
 { 0x210, NCR_ID,  NCR_810,   0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
   "psiop", 'C',     0},
 { 0x210, OLD_NCR_ID, NCR_810A, 0,     0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
   "psiop", 'C',     0},
 { 0x210, OLD_NCR_ID, 0x0003, 0,     0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
   "psiop", 'C',     0},
 { 0x210, OLD_NCR_ID, 0x0006, 0,     0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
   "psiop", 'C',     0},
 { 0x210, OLD_NCR_ID, 0x000F, 0,     0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
   "psiop", 'C',     0},
 { 0x210,ATI_ID,ATI_MACH64_GX,0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "ati",  'C',     0},
 { 0x210,ATI_ID,ATI_MACH64_CX,0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "ati",  'C',     0},
 { 0x210,ATI_ID,ATI_MACH64_CT,0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "ati",  'C',     0},
 { 0x210,CPQ_1280P_VID,CPQ_1280P_DID,0,0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "qvision",  'C',     0},
 { 0x210, S3_ID, S3_TRIO32,   0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "trio",  'C',     0},
 { 0x210, S3_ID, S3_TRIO64,   0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "trio",  'C',     0},

 /* Generic VGA driver */
 { 0x210,    0,      0,       0, BASE_DISPLAY, SUB_VGA,  0,      0,        0,
             0,      0,       0,       1,       1,       0,      0,        0,
    "vga",  'C',     0},

 /* Generic VGA driver, prior to finalized class codes */
 { 0x210,    0,      0,       0, BASE_BC, SUB_PRE_VGA,   0,      0,        0,
             0,      0,       0,       1,       1,       0,      0,        0,
    "vga",  'C',     0},

 { 0x210,QLOGIC_ID,QLOGIC_ISP1020,0,   0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "isp",  'A',     0},
 { 0x210,SIMOS_ID,SIMOS_SCSI,0,   0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "simos",  'A',     0},
 { 0x210, DEC_ID, DEC_7407,   0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "vba",  'A',   vmeconf},
 { 0x210,MYLEX_ID,MYLEX_960P, 0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "xcr",  'C',     0},

 /* Some different PCI ATA/EIDE adapters, some with only limited testing */
 { 0x210, DATATECH_ID, DATATECH_2130S, 0, 0,    0,       0,      0,        0,
	     1,      1,       0,       0,       0,       0,      0,        0,
    "ata", 'C',            0},
 { 0x210, SYMPHONY_ID, SYMPHONY_101P, 0, 0,     0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "ata", 'C',      0},
 { 0x210, SYMPHONY_ID, SYMPHONY_105, 0, 0,      0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "ata", 'C',      0},
 { 0x210, CMDTECH_ID, CMD_PCI0646, 0,  0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "ata", 'C',      0},
 { 0x210, CMDTECH_ID, CMD_PCI0640B, 0, 0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
    "ata", 'C',      0},
 { 0x210, CYPRESS_ID,CYPRESS_82C693,0,BASE_MASS,SUB_IDE, 0,      0,        0,
             1,      1,       0,       1,       1,       0,      0,        0,
    "ata", 'C',      0},
 { 0x210, 0, 0, 0, BASE_SERIAL_BUS, SUB_USB, PIF_USB_OHCI, 0, 0,
          0, 0, 0, 1,               1,       1,            0, 0,
  "ohci", 'A',  0},
 /* Other unknown IDE chips */
 { 0x210,    0,      0,       0, BASE_MASS, SUB_IDE,     0,      0,        0,
             0,      0,       0,       1,       1,       0,      0,        0,
    "ata",  'C',     0},

 { 0x210, CIRRUS_ID, CIRRUS_PD6729, 0, 0,	0,	 0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
  "pcmcia", 'A',   pd6729_conf},

    /*
     * Do not delete any table entries above this line or your system
     * will not configure properly.
     *
     * Add any new controllers or devices here.
     */

    /*
%%% Used by mkdata as placemarker for automatic installation
    */
    

    /*
     * Do not delete this null entry, which terminates the table or your
     * system will not configure properly.
     */
 { 0x210, PCI_VID_INVALID, 0, 0,       0,       0,       0,      0,        0,
             1,      1,       0,       0,       0,       0,      0,        0,
      "",    '',     0}
					/* Null terminator in the table */
};
