/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: cam_config.c,v $
 * Revision 1.1.47.2  1997/01/10  00:15:56  Fred_Knight
 * 	Cleanup some unused externs, remove mips code, and add the
 * 	atadriver struct.
 * 	[1997/01/09  21:32:53  Fred_Knight]
 *
 * Revision 1.1.39.3  1995/08/22  20:21:50  David_Gagne
 * 	Remove cam_tape from the peripheral driver table.
 * 	Remove non-OSF code.
 * 	[1995/08/21  17:56:36  David_Gagne]
 * 
 * Revision 1.1.39.2  1995/07/05  15:12:35  James_Smart
 * 	Removed cam_disk from the peripheral driver table.
 * 	Added the cam_ctlr_attach() routine to all "driver" structures.
 * 	[1995/07/04  11:31:52  James_Smart]
 * 
 * Revision 1.1.35.5  1994/10/17  20:14:51  Brian_Nadeau
 * 	Remove psiop references from the ispdriver structure.
 * 	[1994/10/17  20:14:16  Brian_Nadeau]
 * 
 * Revision 1.1.35.4  1994/09/22  17:46:57  Brian_Nadeau
 * 	Merge of Hardware BL4 changes
 * 	[1994/09/22  17:30:10  Brian_Nadeau]
 * 
 * Revision 1.1.35.3  1994/08/18  20:52:17  Brian_Nadeau
 * 	merge of Hardware BL3 changes
 * 	[1994/08/18  20:49:58  Brian_Nadeau]
 * 
 * Revision 1.1.35.2  1994/07/26  15:43:50  Kate_Baumgartner
 * 	Initial GAMMA support
 * 	[1994/07/25  19:07:19  Kate_Baumgartner]
 * 
 * Revision 1.1.34.3  1994/08/12  17:36:41  Stuart_Hollander
 * 	name change: 2100_A200 ==> 1000
 * 	[1994/08/10  20:22:05  Stuart_Hollander]
 * 
 * Revision 1.1.34.2  1994/07/21  00:42:23  Gary_Dupuis
 * 	Added a case for Mikasa (DEC_2100_A200 in cam_probe.
 * 	[1994/07/20  19:35:54  Gary_Dupuis]
 * 
 * Revision 1.1.22.7  1994/05/10  21:26:10  Donald_Dutile
 * 	Add isp/qlogic isp1020.
 * 	[1994/05/05  19:04:50  Donald_Dutile]
 * 
 * Revision 1.1.22.6  1994/04/11  12:56:38  Stuart_Hollander
 * 	Revision 1.1.17.4  1994/03/18  17:16:56  Kate_Baumgartner
 * 	Changed name from sable to kn450, from ALPHASABLE to DEC_2100_A500
 * 	[1994/03/13  17:33:53  Kate_Baumgartner]
 * 
 * Revision 1.1.22.5  1994/03/29  21:48:57  Janet_Schank
 * 	Added PZA driver support.
 * 	[1994/03/21  13:58:37  Janet_Schank]
 * 
 * Revision 1.1.22.4  1994/03/28  00:49:18  Tim_Hoskins
 * 	convert rcsid to pragma ident
 * 	[1994/03/28  00:37:34  Tim_Hoskins]
 * 
 * Revision 1.1.22.3  1994/03/03  00:13:23  Mike_MacKay
 * 	Include the tcds.h file.
 * 	[1994/02/28  21:04:09  Mike_MacKay]
 * 
 * 	Made asc functions also dependent on tcds.
 * 	[1994/02/28  18:43:29  Mike_MacKay]
 * 
 * 	Added support for new "scsi" controller which all SCSI
 * 	devices will be connected to.  TZA, ASC, PZA, etc. will
 * 	all be buses which "scsi" will be connected to.
 * 	[1994/02/26  01:35:41  Mike_MacKay]
 * 
 * Revision 1.1.22.2  1994/01/23  21:11:47  Stuart_Hollander
 * 	Merge from agoshw2 bl2 to gold bl8
 * 	[1994/01/12  21:07:40  Stuart_Hollander]
 * 
 * Revision 1.1.17.3  1994/01/06  20:07:29  John_Gallant
 * 	Added in the driver info for the NCR 53c810 SCSI controller.
 * 	[1994/01/06  15:52:23  John_Gallant]
 * 
 * Revision 1.1.17.2  1993/11/12  17:58:53  Kate_Baumgartner
 * 	added sable support
 * 	[1993/11/08  18:24:48  Kate_Baumgartner]
 * 
 * Revision 1.1.14.3  1993/08/13  20:42:52  Kuo_Hsieh
 * 	Corrected a newline which caused compiling fail.
 * 	[1993/07/14  14:48:11  Kuo_Hsieh]
 * 
 * 	Added TZA adapter support.
 * 	[1993/07/07  22:02:52  Kuo_Hsieh]
 * 
 * Revision 1.1.14.2  1993/06/24  22:36:40  Randall_Brown
 * 	Submit of AGOSHW pool into Sterling
 * 	[1993/06/24  21:18:35  Randall_Brown]
 * 
 * Revision 1.1.8.4  1993/03/16  23:01:09  Paul_Grist
 * 	Jensen name change to DEC_2000_300
 * 	[1993/03/16  22:57:22  Paul_Grist]
 * 
 * Revision 1.1.8.3  1993/01/07  10:39:47  Timothy_Burke
 * 	Changed ALPHAJENSEN to ALPHA_JENSEN to get to compile.
 * 	Not sure how this problem cropped up??
 * 	[93/01/07  10:38:18  Timothy_Burke]
 * 
 * Revision 1.1.8.2  92/11/13  16:35:15  Paul_Grist
 * 	Initial EISA SCSI submit for jtw - Add support for aha (adaptech
 * 	1742 scsi)
 * 	[92/11/13  16:08:18  Paul_Grist]
 * 
 * Revision 1.1.3.11  92/08/20  12:53:42  Peter_Schulter
 * 	Code cleanup: Changed Ruby to DEC7000 and Cobra to DEC4000.
 * 	[92/08/20  10:21:30  Peter_Schulter]
 * 
 * Revision 1.1.3.10  92/08/10  10:44:27  Peter_Schulter
 * 	Chnaged name of SIOP driver to siopco.
 * 	[92/08/06  10:29:28  Peter_Schulter]
 * 
 * Revision 1.1.3.9  92/06/25  20:20:24  Tim_Hoskins
 * 	Removed "BOP" references from alpha data structures.
 * 	[92/06/25  20:18:24  Tim_Hoskins]
 * 
 * Revision 1.1.3.8  92/06/25  17:45:24  Peter_Schulter
 * 	merged in Silver BL8
 * 	Revision 1.1.3.5  92/06/02  10:53:22  cam_proj_Janet_Schank
 * 	Moved all CAM include files out of sys.  Removed all "BOP" macros.
 * 	[92/05/26  13:02:47  Janet_Schank]
 * 
 * 	Added KZQSA support
 * 	[92/03/06  14:32:20  William_Dallas]
 * 	Revision 1.1.3.4  92/05/07  13:22:53  Thomas_Tierney
 * 	Merged Maria Vella's CAM dev_t expansion work.
 * 	[92/04/21  16:17:01  Thomas_Tierney]
 * 
 * Revision 1.1.3.7  92/06/03  12:50:08  Peter_Schulter
 * 	merged in Silver BL7
 * 	Revision 1.1.3.4  92/05/07  13:22:53  Thomas_Tierney
 * 
 * 	Merged Maria Vella's CAM dev_t expansion work.
 * 	[92/04/21  16:17:01  Thomas_Tierney]
 * 
 * 	Revision 1.1.5.2  92/03/06  14:49:34  William_Dallas
 * 	Revision 1.1.3.6  92/04/18  11:52:25  Andrew_Duane
 * 	Removed accidentally duplicated DS_5400 case ion cam_probe().
 * 	[92/04/18  11:51:53  Andrew_Duane]
 * 
 * Revision 1.1.3.5  92/04/14  15:23:17  Peter_Schulter
 * 	merged in Silver BL5
 * 	Revision 1.1.5.2  92/03/06  14:49:34  William_Dallas
 * 	     Added KZQSA support
 * 	     [92/03/06  14:32:20  William_Dallas]
 * 	[92/04/14  15:06:41  Peter_Schulter]
 * 
 * Revision 1.1.3.4  92/04/02  00:13:52  Ronald_Heglie
 * 	Added LASER/Ruby XZA/SCSI support.
 * 	[92/04/02  00:06:29  Ronald_Heglie]
 * 
 * Revision 1.1.3.3  92/04/01  19:01:31  Peter_Schulter
 * 	Added interface to Cobra SCSI drive (SIOP).
 * 	[92/04/01  18:59:36  Peter_Schulter]
 * 
 * Revision 1.1.3.2  92/03/18  13:33:46  Al_Delorey
 * 	From Silver: AG_BL5
 * 	[92/03/18  11:59:19  Al_Delorey]
 * 	Added include of <mach/vm_param.h> for Alpha.
 * 	[92/02/21  13:28:00  Janet_Schank]
 * 
 * 	Made 64bit modifications
 * 	[92/01/31  09:37:02  Janet_Schank]
 * 
 * 	Merged in changes from LA.
 * 	[92/01/28  18:03:01  Janet_Schank]
 * 
 * 	CAM support added
 * 	[92/01/17  11:14:49  Janet_Schank]
 * 
 * Revision 1.1.1.2  92/03/17  15:01:31  devbld_gsf
 * 	First AG_BL5 version.  Moved from Ag baselevel delivery tree.
 * 
 * $EndLog$
 */
#pragma ident "@(#)$RCSfile: cam_config.c,v $ $Revision: 1.1.47.2 $ (DEC) $Date: 1997/01/10 00:15:56 $"

/************************************************************************
 *
 * File:	cam_config.c
 * Date:	March 8, 1991
 * Author:	Robin T. Miller
 *
 * Description:
 *	CAM peripheral driver configuration information.
 *
 * Modification History:
 *
 *	05/24/91	maria
 *			Added an entry in the CAM peripheral driver
 *			configuration table for the CAM disk driver.
 *
 *	06/07/91	maria
 *			Changed uba_driver structure to reflect the
 *			use of rz/asc for booting.
 *			Changed ifdef checks of NCAM to be NASC.
 *	06/20/91	dallas
 *			Added ctape to this file once again.
 *	06/28/91        rps
 *                      Added new configuration code.  Dynamic allocation
 *                      and addition of sim's.  
 *	07/03/91	jag
 *			changed the routines cdrv_*() to ccfg_*().
 *	07/31/91	dallas
 *			Added tz routines for the wrapper
 *	12/04/91	jag
 *			Corrected the comments for VENDORS to add their drivers.
 *
 */

/*
 * This version of cam_config.c is intended for OSF use.
 */
#include <io/common/iotypes.h>
#include <sys/types.h>			/* system level types */

#include <sys/param.h>			/* system level parameter defs */
#include <sys/buf.h>
#include <mach/vm_param.h>
#include <io/cam/dec_cam.h>
#include <io/cam/cam.h>
#include <hal/cpuconf.h>
#include <io/common/devdriver.h>
#include <io/cam/cam_config.h>
#include <io/cam/sim_config.h>
#include <io/cam/cam_debug.h>

#include "asc.h"
#include "tcds.h"
#include "tza.h"
#include "pza.h"
#include "scsi.h"
#include "xza.h"
#include "siop.h"
#include "psiop.h"
#include "aha.h"
#include "ata.h"
#include "isp.h"
#include "simos.h"

extern int cpu;

#if NSCSI > 0
int cam_probe();

/* JAG: these should be together */
caddr_t camstd[] = { 0 };
extern struct controller *camminfo[];
extern struct device *camdinfo[];

extern int ccfg_ctlr_attach();
extern int ccfg_slave();
extern int ccfg_attach(); 

extern CAM_HBA_LIST_ENTRY cam_hba_list[];
extern CAM_DME_LIST_ENTRY cam_dme_list[];
extern int cam_hba_entries;
extern int cam_hba_limit;
extern int cam_dme_entries;
extern int cam_dme_limit;

/*
 * Setup the driver structures for auto-configuration code.
 */

struct driver camdriver = {
	cam_probe,		/* CAM SIM ASC HBA probe function.	*/
	ccfg_slave,		/* CAM cdrv slave function.		*/
	ccfg_ctlr_attach,
	ccfg_attach,		/* CAM cdrv attach function.		*/
	(int (*)()) 0,		/* Driver start transfer function.	*/
	camstd,			/* Pointer to device CSR addresses.	*/
	"rz",			/* Name of the device.			*/
	camdinfo,		/* Pointers to device structures.	*/
	"cam",			/* Name of the controller.		*/
	camminfo,		/* Pointers to controller structures.	*/
	0,			/* Want exclusive use of bdp's flag.	*/
	0,			/* Size of first csr area .		*/
	0,			/* Address space of first csr area.	*/
	0,			/* Size of second csr area.		*/
	0 			/* Address space of second csr area.	*/
};

/*
 * "scsi" is the "generic" scsi controller which all SCSI devices
 * are attached to.  "scsi" is then attached to various buses such
 * as tza, tcds, and pza.
 */
int scsiintr() {}
struct driver scsidriver; /* These aren't used, but are needed to satisfy
			   * the references in ioconf.c.
			   */

#if (NASC > 0) || (NTCDS > 0)
/*
 * Controller driver structure for ASC Host Bus Adapter (HBA).
 */
extern int sim94_probe();

struct driver ascdriver = {
	sim94_probe,		/* CAM SIM ASC HBA probe function.	*/
	ccfg_slave,		/* CAM cdrv slave function.		*/
	ccfg_ctlr_attach,
	ccfg_attach,		/* CAM cdrv attach function.		*/
	(int (*)()) 0,		/* Driver start transfer function.	*/
	camstd,			/* Pointer to device CSR addresses.	*/
	"rz",			/* Name of the device.			*/
	camdinfo,		/* Pointers to device structures.	*/
	"scsi",			/* Name of the controller.		*/
	camminfo,		/* Pointers to controller structures.	*/
	0,			/* Want exclusive use of bdp's flag.	*/
	0,			/* Size of first csr area .		*/
	0,			/* Address space of first csr area.	*/
	0,			/* Size of second csr area.		*/
	0 			/* Address space of second csr area.	*/
};
#endif /* NASC > 0 || NTCDS > 0 */

#if NXZA > 0
/*
** Controller driver structure for the XZA/SCSI adapter.
*/
extern skz_probe();

struct driver skzdriver = {
	skz_probe,		/* A stub for XZA */
	ccfg_slave,		/* CAM cdrv slave function.		*/
	ccfg_ctlr_attach,
	ccfg_attach,		/* CAM cdrv attach function.		*/
	(int (*)()) 0,		/* Driver start transfer function.	*/
	camstd,			/* Pointer to device CSR addresses.	*/
	"rz",			/* Name of the device.			*/
	camdinfo,		/* Pointers to device structures.	*/
	"scsi",			/* Name of the controller.		*/
	camminfo,		/* Pointers to controller structures.	*/
	0,			/* Want exclusive use of bdp's flag.	*/
	0,			/* Size of first csr area .		*/
	0,			/* Address space of first csr area.	*/
	0,			/* Size of second csr area.		*/
	0 			/* Address space of second csr area.	*/
};

#endif /* NXZA > 0 */


#if NSIOP > 0

/* Cobra SCSI driver */
extern siop_probe();

struct driver siopdriver = {
    siop_probe,       	    /* CAM SIM SIOP HBA probe function.      */
    ccfg_slave,             /* CAM cdrv slave function.             */
    ccfg_ctlr_attach,
    ccfg_attach,            /* CAM cdrv attach function.            */
    (int (*)()) 0,          /* Driver start transfer function.      */
    camstd,                 /* Pointer to device CSR addresses.     */
    "siop",                 /* Name of the device.                  */
    camdinfo,               /* Pointers to device structures.       */
    "scsi",                 /* Name of the controller.              */
    camminfo,               /* Pointers to controller structures.   */
    0,                      /* Want exclusive use of bdp's flag.    */
    0,                      /* Size of first csr area .             */
    0,                      /* Address space of first csr area.     */
    0,                      /* Size of second csr area.             */
    0                       /* Address space of second csr area.    */
};

#endif /* NSIOP > 0 */

#if NTZA > 0
/*
 * Controller driver structure for TZA Host Bus Adapter (HBA).
 */
extern int kztsa_probe();

struct driver tzadriver = {
        kztsa_probe,            /* CAM SIM ASC HBA probe function.      */
        ccfg_slave,             /* CAM cdrv slave function.             */
        ccfg_ctlr_attach,
        ccfg_attach,            /* CAM cdrv attach function.            */
        (int (*)()) 0,          /* Driver start transfer function.      */
        camstd,                 /* Pointer to device CSR addresses.     */
        "tza",                  /* Name of the device.                  */
        camdinfo,               /* Pointers to device structures.       */
        "scsi",                 /* Name of the controller.              */
        camminfo,               /* Pointers to controller structures.   */
        0,                      /* Want exclusive use of bdp's flag.    */
        0,                      /* Size of first csr area .             */
        0,                      /* Address space of first csr area.     */
        0,                      /* Size of second csr area.             */
        0                       /* Address space of second csr area.    */
};
#endif /* NTZA > 0 */

#if NPZA > 0
/*
 * Controller driver structure for PZA Host Bus Adapter (HBA).
 */
extern int pza_probe();

struct driver pzadriver = {
        pza_probe,              /* CAM SIM ASC HBA probe function.      */
        ccfg_slave,             /* CAM cdrv slave function.             */
        ccfg_ctlr_attach,
        ccfg_attach,            /* CAM cdrv attach function.            */
        (int (*)()) 0,          /* Driver start transfer function.      */
        camstd,                 /* Pointer to device CSR addresses.     */
        "pza",                  /* Name of the device.                  */
        camdinfo,               /* Pointers to device structures.       */
        "scsi",                 /* Name of the controller.              */
        camminfo,               /* Pointers to controller structures.   */
        0,                      /* Want exclusive use of bdp's flag.    */
        0,                      /* Size of first csr area .             */
        0,                      /* Address space of first csr area.     */
        0,                      /* Size of second csr area.             */
        0                       /* Address space of second csr area.    */
};
#endif /* NPZA > 0 */

#if NATA > 0

/*
 * Controller driver structure for ATA/IDE Bus Adapter (HBA).
 */
extern ata_probe();

struct driver atadriver = {
    ata_probe,       	    /* CAM SIM AHA HBA probe function.      */
    ccfg_slave,             /* CAM cdrv slave function.             */
    ccfg_ctlr_attach,
    ccfg_attach,            /* CAM cdrv attach function.            */
    (int (*)()) 0,          /* Driver start transfer function.      */
    camstd,                 /* Pointer to device CSR addresses.     */
    "ata",                  /* Name of the device.                  */
    camdinfo,               /* Pointers to device structures.       */
    "scsi",                  /* Name of the controller.              */
    camminfo,               /* Pointers to controller structures.   */
    0,                      /* Want exclusive use of bdp's flag.    */
    0,                      /* Size of first csr area .             */
    0,                      /* Address space of first csr area.     */
    0,                      /* Size of second csr area.             */
    0                       /* Address space of second csr area.    */
};

#endif /* NATA > 0 */

#if NAHA > 0

/* Jensen SCSI driver */
extern aha_probe();

struct driver ahadriver = {
    aha_probe,       	    /* CAM SIM AHA HBA probe function.      */
    ccfg_slave,             /* CAM cdrv slave function.             */
    ccfg_ctlr_attach,
    ccfg_attach,            /* CAM cdrv attach function.            */
    (int (*)()) 0,          /* Driver start transfer function.      */
    camstd,                 /* Pointer to device CSR addresses.     */
    "aha",                  /* Name of the device.                  */
    camdinfo,               /* Pointers to device structures.       */
    "scsi",                  /* Name of the controller.              */
    camminfo,               /* Pointers to controller structures.   */
    0,                      /* Want exclusive use of bdp's flag.    */
    0,                      /* Size of first csr area .             */
    0,                      /* Address space of first csr area.     */
    0,                      /* Size of second csr area.             */
    0                       /* Address space of second csr area.    */
};

#endif /* NAHA > 0 */


#if NPSIOP > 0

/* PCI NCR 53c810 SCSI driver */
extern psiop_probe();

struct driver psiopdriver = {
    psiop_probe,       	    /* CAM SIM PSIOP HBA probe function.      */
    ccfg_slave,             /* CAM cdrv slave function.             */
    ccfg_ctlr_attach,
    ccfg_attach,            /* CAM cdrv attach function.            */
    (int (*)()) 0,          /* Driver start transfer function.      */
    camstd,                 /* Pointer to device CSR addresses.     */
    "psiop",                /* Name of the device.                  */
    camdinfo,               /* Pointers to device structures.       */
    "scsi",                /* Name of the controller.              */
    camminfo,               /* Pointers to controller structures.   */
    0,                      /* Want exclusive use of bdp's flag.    */
    0,                      /* Size of first csr area .             */
    0,                      /* Address space of first csr area.     */
    0,                      /* Size of second csr area.             */
    0                       /* Address space of second csr area.    */
};

#endif /* NPSIOP > 0 */

#if NISP > 0

/* PCI QLOGIC ISP1020 SCSI driver */
extern isp_probe();

struct driver ispdriver = {
    isp_probe,              /* CAM SIM ISP HBA probe function.      */
    ccfg_slave,             /* CAM cdrv slave function.             */
    ccfg_ctlr_attach,
    ccfg_attach,            /* CAM cdrv attach function.            */
    (int (*)()) 0,          /* Driver start transfer function.      */
    camstd,                 /* Pointer to device CSR addresses.     */
    "isp",                  /* Name of the device.                  */
    camdinfo,               /* Pointers to device structures.       */
    "scsi",                 /* Name of the controller.              */
    camminfo,               /* Pointers to controller structures.   */
    0,                      /* Want exclusive use of bdp's flag.    */
    0,                      /* Size of first csr area .             */
    0,                      /* Address space of first csr area.     */
    0,                      /* Size of second csr area.             */
    0                       /* Address space of second csr area.    */
};

#endif /* NISP > 0 */

#if NSIMOS > 0


extern simos_probe();
extern int simos_pci_attach(), simos_unload();

struct driver simos_driver = {
    simos_probe,              /* CAM SIM ISP HBA probe function.      */
    ccfg_slave,             /* CAM cdrv slave function.             */
    ccfg_ctlr_attach,
    ccfg_attach,            /* CAM cdrv attach function.            */
    (int (*)()) 0,          /* Driver start transfer function.      */
    camstd,                 /* Pointer to device CSR addresses.     */
    "simos",                  /* Name of the device.                  */
    camdinfo,               /* Pointers to device structures.       */
    "scsi",                 /* Name of the controller.              */
    camminfo,               /* Pointers to controller structures.   */
    0,                      /* Want exclusive use of bdp's flag.    */
    0,                      /* Size of first csr area .             */
    0,                      /* Address space of first csr area.     */
    0,                      /* Size of second csr area.             */
    0                       /* Address space of second csr area.    */
};

#endif /* NSIMOS > 0 */

/* VENDOR: Add the extern declaratios for your hardware following this
    comment line! */

/*
 * CAM Peripheral Driver Configuration Table.
 */

int
pdrv_dummy_sa_rtn()
{
 return( 0 );
}

CAM_PERIPHERAL_DRIVER cam_peripheral_drivers[] = {

/* VENDOR: Add your hardware entries following this comment line! */


/* VENDOR: Add your hardware entries before this comment line! */

	{ "zz", pdrv_dummy_sa_rtn, pdrv_dummy_sa_rtn }
};

int cam_pdrv_entries =
  (sizeof(cam_peripheral_drivers) / sizeof(cam_peripheral_drivers[0])) - 1;

void
init_cam_components( void )
{
}

cam_probe(csr, prb)
caddr_t csr;
struct controller *prb;
{
    int retval = 1;
    char *hbaname;
    char *dmename;
    char modname[32];             /* this shouldn't be hard coded - RPS */

    switch( cpu )
        {
	case DEC_4000:
	    hbaname = "siopco";
	    dmename = "null";
	    break;

        case DEC_2000_300:
	case DEC_1000:
	case DEC_2100_A500:
	case DEC_2100_C500:
            hbaname = "aha";
            dmename = "null";
            break;

        default:
	    if ( prb->ctlr_num == 0 )               /* base scsi? */
	      {
		hbaname = "asc";
		dmename = "dma94";
	      }
            else                               /* TC scsi */
	      {
		if( tc_addr_to_name( csr, modname ) == -1)
		  printf("cam_probe: tc_addr_to_name failed ");
		hbaname = modname;
		dmename = modname;
	      }
	    break;
	}

    if ( name_lookup_hba_probe( hbaname, csr, prb ) != CAM_REQ_CMP )
        {
	/* 
	 * If the attach fails don't do any further initialization.
	 */
	PRINTD( prb->ctlr_num, NOBTL, NOBTL, CAMD_INOUT,
	   ("cam_probe: hba probe lookup ('%s') failed.\n", hbaname ) );
	retval = CAM_FAILURE;
        }

    return retval;
    }

#endif
