/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: sim_config.c,v $
 * Revision 1.1.82.2  1997/01/10  00:26:39  Fred_Knight
 * 	Add ATA sim hooks.
 * 	[1997/01/09  21:39:38  Fred_Knight]
 *
 * Revision 1.1.74.3  1995/05/24  22:13:28  Fred_Knight
 * 	Merge from PTLITEOS_BL4
 * 	[1995/05/24  22:01:38  Fred_Knight]
 * 
 * Revision 1.1.74.2  1995/05/01  20:37:49  Naresh_Dharnidharka
 * 	Merge from HW4OS_BL3
 * 	[1995/05/01  20:28:53  Naresh_Dharnidharka]
 * 
 * Revision 1.1.69.4  1995/03/14  20:18:32  Naresh_Dharnidharka
 * 	Deleted obsolete mips code. Removed platform dependent code to
 * 	default for all platforms except DEC3000 and DEC4000. New platforms
 * 	should not need to modify this file.
 * 	[1995/03/10  19:48:58  Naresh_Dharnidharka]
 * 
 * 	Move case statement for DEC7000 and DEC_21000.
 * 	[1995/03/09  16:29:34  Naresh_Dharnidharka]
 * 
 * 	Add 810 support for Turbolaser.
 * 	[1995/03/06  18:15:55  Naresh_Dharnidharka]
 * 
 * Revision 1.1.69.3  1995/01/13  19:55:29  Naresh_Dharnidharka
 * 	Add KZPSA support for Turbolaser.
 * 	[1995/01/09  15:24:19  Naresh_Dharnidharka]
 * 
 * Revision 1.1.69.2  1995/01/12  21:51:29  Eric_Rasmussen
 * 	Add EB64+ and EB66 support
 * 	[1994/12/21  21:24:56  Eric_Rasmussen]
 * 
 * Revision 1.1.50.12  1994/11/22  18:32:00  Naresh_Dharnidharka
 * 	merge after Robin's submit
 * 	[1994/11/22  18:22:21  Naresh_Dharnidharka]
 * 
 * 	merger mania
 * 	[1994/11/21  23:44:20  Naresh_Dharnidharka]
 * 
 * 	Change DECTLASER to DEC21000
 * 	[1994/11/21  22:43:59  Naresh_Dharnidharka]
 * 
 * Revision 1.1.50.11  1994/11/22  17:44:00  Robin_Lewis
 * 	merge from bmerge checkout
 * 	[1994/11/22  17:13:00  Robin_Lewis]
 * 
 * 	alcor to kn20aa name change
 * 	[1994/11/22  15:10:08  Robin_Lewis]
 * 
 * Revision 1.1.50.10  1994/09/22  17:47:52  Brian_Nadeau
 * 	Merge of Hardware BL4 changes
 * 	[1994/09/22  17:30:39  Brian_Nadeau]
 * 
 * Revision 1.1.50.9  1994/08/29  18:45:08  Naresh_Dharnidharka
 * 	merge to nightly
 * 	[1994/08/29  13:57:26  Naresh_Dharnidharka]
 * 
 * 	Turbolaser ITIOP support.
 * 	[1994/08/26  13:57:53  Naresh_Dharnidharka]
 * 
 * Revision 1.1.50.8  1994/08/18  20:50:58  Brian_Nadeau
 * 	merge of Hardware BL3 changes
 * 	[1994/08/18  20:49:16  Brian_Nadeau]
 * 
 * Revision 1.1.57.7  1994/08/12  17:36:43  Stuart_Hollander
 * 	name change: 2100_A200 ==> 1000
 * 	[1994/08/10  20:22:16  Stuart_Hollander]
 * 
 * Revision 1.1.50.7  1994/08/08  21:06:04  Brian_Nadeau
 * 	add isp (qlogic) to the cam hba dme attach routine
 * 	[1994/08/08  20:31:18  Brian_Nadeau]
 * 
 * Revision 1.1.57.6  1994/07/27  22:20:12  Brett_Sampson
 * 	merge of Gold BL12 changes
 * 	[1994/07/27  22:06:58  Brett_Sampson]
 * 
 * Revision 1.1.50.6  1994/07/26  15:43:52  Kate_Baumgartner
 * 	Initial GAMMA support
 * 	[1994/07/25  19:07:33  Kate_Baumgartner]
 * 
 * Revision 1.1.57.5  1994/07/21  00:42:26  Gary_Dupuis
 * 	Added Mikasa support.
 * 	[1994/07/20  19:36:03  Gary_Dupuis]
 * 
 * Revision 1.1.57.4  1994/07/15  17:11:04  Vikas_Sontakke
 * 	Add support for AXPpci33
 * 	[1994/06/28  13:07:09  Vikas_Sontakke]
 * 
 * Revision 1.1.50.5  1994/07/14  13:27:22  Naresh_Dharnidharka
 * 	EV5 to HW3OS_BL2 merge
 * 	[1994/07/13  18:49:18  Naresh_Dharnidharka]
 * 
 * Revision 1.1.30.12  1994/07/01  20:43:41  John_Meneghini
 * 	- Declare dummy xza_enable_intr() routine if NXZA == 0.  This is
 * 	  needed because it is possible to have a Ruby with no XZA configured.
 * 	[1994/07/01  13:34:38  John_Meneghini]
 * 
 * Revision 1.1.57.3  1994/06/16  00:02:03  Ronald_Krueger
 * 	merge goldos bl11
 * 	added AXPVME 64 support
 * 	[1994/06/15  23:41:27  Ronald_Krueger]
 * 
 * Revision 1.1.50.4  1994/05/17  18:31:41  Naresh_Dharnidharka
 * 	EV5 and GOLD_BL10 merge
 * 	[1994/05/10  19:46:17  Naresh_Dharnidharka]
 * 
 * Revision 1.1.30.11  1994/05/10  21:26:25  Donald_Dutile
 * 	Add isp/qlogic isp1020.
 * 	[1994/05/05  19:05:31  Donald_Dutile]
 * 
 * Revision 1.1.30.10  1994/05/06  15:49:06  Janet_Schank
 * 	Made fixes for PZA.
 * 	[1994/05/06  15:48:14  Janet_Schank]
 * 
 * Revision 1.1.30.9  1994/04/19  21:57:13  Stuart_Hollander
 * 	merge agoshw2 bl5 to gold
 * 	Revision 1.1.24.6  1994/04/15  16:38:42  William_Burns
 * 	Avanti name change.
 * 	[1994/04/08  19:55:05  William_Burns]
 * 
 * Revision 1.1.30.8  1994/04/11  12:56:43  Stuart_Hollander
 * 	Revision 1.1.24.5  1994/03/18  17:17:05  Kate_Baumgartner
 * 	Changed name from sable to kn450, from ALPHASABLE to DEC_2100_A500
 * 	[1994/03/13  17:33:59  Kate_Baumgartner]
 * 
 * Revision 1.1.30.7  1994/03/29  21:49:08  Janet_Schank
 * 	Added PZA driver support.
 * 	[1994/03/21  13:58:50  Janet_Schank]
 * 
 * Revision 1.1.30.6  1994/03/28  01:20:13  Tim_Hoskins
 * 	convert rcsid to pragma ident
 * 	[1994/03/28  01:11:36  Tim_Hoskins]
 * 
 * Revision 1.1.30.5  1994/03/21  19:26:40  Theresa_Chin
 * 	Replaced 'kztsa_adap_reset' with 'kztsa_reset' since 'kztsa_adap_reset'
 * 	is an internal routine to KZTSA driver.
 * 	[1994/03/18  16:21:23  Theresa_Chin]
 * 
 * Revision 1.1.30.4  1994/03/03  00:13:38  Mike_MacKay
 * 	Merge to nightly.
 * 	[1994/03/02  20:10:43  Mike_MacKay]
 * 
 * 	Check for TCDS, not just ASC.
 * 	[1994/02/28  21:02:16  Mike_MacKay]
 * 
 * 	Removed old sii and kzq references.
 * 	[1994/02/26  01:37:44  Mike_MacKay]
 * 
 * Revision 1.1.30.3  1994/02/25  21:22:44  Stuart_Hollander
 * 	merge agoshw2 bl3 to gold
 * 	[1994/02/23  00:54:40  Stuart_Hollander]
 * 
 * Revision 1.1.30.2  1994/01/23  21:12:43  Stuart_Hollander
 * 	Merge from agoshw2 bl2 to gold bl8
 * 	[1994/01/12  22:12:45  Stuart_Hollander]
 * 
 * Revision 1.1.24.4  1994/01/10  15:04:19  William_Burns
 * 	Add Mustang and Avanti.
 * 	[1994/01/10  12:57:44  William_Burns]
 * 
 * Revision 1.1.24.3  1994/01/06  20:09:27  John_Gallant
 * 	Added in the attachment support for the NCR 53c810 SCSI
 * 	code.  Some minor changes in the error prints.  There
 * 	will have to be another change to the attach stuff to
 * 	look for PCI and not be dependent on SABLE.
 * 	[1994/01/06  16:02:30  John_Gallant]
 * 
 * Revision 1.1.24.2  1993/11/12  17:59:07  Kate_Baumgartner
 * 	added sable support
 * 	[1993/11/08  18:25:31  Kate_Baumgartner]
 * 
 * Revision 1.1.21.4  1993/09/22  15:06:08  Fred_Knight
 * 	Put sim_enable_interrupt back using bus rather than cpu.
 * 	[1993/09/13  21:05:52  Fred_Knight]
 * 
 * Revision 1.1.21.3  1993/08/13  20:57:58  Kuo_Hsieh
 * 	Added TZA adapter support.
 * 	[1993/07/30  20:31:23  Kuo_Hsieh]
 * 
 * Revision 1.1.21.2  1993/06/24  22:37:07  Randall_Brown
 * 	Submit of AGOSHW pool into Sterling
 * 	[1993/06/24  21:18:53  Randall_Brown]
 * 
 * Revision 1.1.11.6  1993/05/19  19:36:38  Gary_Dupuis
 * 	Merge with Ag maintenance BL3.
 * 	[1993/05/19  19:11:22  Gary_Dupuis]
 * 
 * Revision 1.1.17.2  1993/04/21  21:51:13  John_Flanagan
 * 	Pull pre-BL4 install fix into BL3 kitbld area.  Work done
 * 	by Fred Knight.
 * 	[1993/04/21  21:49:52  John_Flanagan]
 * 
 * Revision 1.1.13.5  1993/04/21  21:13:36  Fred_Knight
 * 	Add back Pelican case (That I removed accidently).
 * 	[1993/04/21  21:11:53  Fred_Knight]
 * 
 * Revision 1.1.11.5  1993/04/20  21:44:42  Paul_Grist
 * 	merge jensen support into agosmaint_bl2
 * 	[1993/04/20  21:38:16  Paul_Grist]
 * 
 * Revision 1.1.13.4  1993/04/10  00:36:38  Fred_Knight
 * 	Correct PMAZC-AA name (as per H/W).
 * 	[1993/04/09  21:54:07  Fred_Knight]
 * 
 * 	Remove CPU specific entries.  Removed spurious_interrupt code
 * 	since chip is now setup prior to enabling interrupts.  Add fake
 * 	name PMAZ-FS for the fast tcds chip option (see tcds_adapt.c)
 * 	[1993/04/07  15:48:42  Fred_Knight]
 * 
 * Revision 1.1.13.3  1993/04/09  21:48:33  Fred_Knight
 * 	Remove CPU specific entries.  Removed spurious_interrupt code
 * 	since chip is now setup prior to enabling interrupts.  Add fake
 * 	name PMAZ-FS for the fast tcds chip option (see tcds_adapt.c)
 * 	[1993/04/07  15:48:42  Fred_Knight]
 * 
 * Revision 1.1.11.4  1993/03/16  23:01:12  Paul_Grist
 * 	Jensen name change to DEC_2000_300
 * 	[1993/03/16  22:57:26  Paul_Grist]
 * 
 * Revision 1.1.13.2  1993/02/26  17:07:22  Randall_Brown
 * 	Merge Pelican support into Maintenance pool
 * 	[93/02/26  16:20:44  Randall_Brown]
 * 
 * Revision 1.1.11.3  1993/01/06  15:26:17  Timothy_Burke
 * 	Jensen merge BL9 to BL11.
 * 	[93/01/06  15:25:09  Timothy_Burke]
 * 
 * Revision 1.1.9.4  92/12/28  16:42:54  Randall_Brown
 * 	Revision 1.1.3.22  92/11/19  17:16:44  John_Gallant
 * 	The Flamingo DME labels were changed to TCDS.
 * 	[92/11/19  16:03:06  John_Gallant]
 * 
 * Revision 1.1.11.2  92/11/13  16:36:37  Paul_Grist
 * 	Initial EISA SCSI submit for jtw - Add support for aha (adaptech
 * 	1742 scsi)
 * 	[92/11/13  16:10:31  Paul_Grist]
 * 
 * Revision 1.1.9.3  92/10/16  16:15:37  Randall_Brown
 * 	Merged in BL9_rev11 changes
 * 	[92/10/16  15:56:45  Randall_Brown]
 * 
 * Revision 1.1.9.2  92/10/05  16:44:58  Randall_Brown
 * 	Added Pelican Support
 * 	[92/10/05  15:34:11  Randall_Brown]
 * 
 * Revision 1.1.3.21  92/09/28  18:28:37  Ronald_Hegli
 * 	Finally broke down and changed the XZA to use the
 * 	null dme, because ss_abort_done calls DME_END and
 * 	it'll be safer in the long run to just 'null' all
 * 	of the dme routines than to get bit when turning
 * 	on new functionality, such as command aborts, which
 * 	is being activated now that's it's available in
 * 	XZA firmware.
 * 	[92/09/28  18:09:16  Ronald_Hegli]
 * 
 * Revision 1.1.3.20  92/09/10  14:36:00  Farrell_Woods
 * 	More places that needed to know the name PMAZB-AA, etc.
 * 	[92/09/10  14:32:29  Farrell_Woods]
 * 
 * 	Fix for PMAZB-AA configuration: have code look for
 * 	PMAZB-AA instead of PMAZ-DS.
 * 	[92/09/09  14:59:58  Farrell_Woods]
 * 
 * Revision 1.1.3.19  92/08/25  09:11:05  Randall_Brown
 * 	Removed Pelican code
 * 	[92/08/25  08:39:22  Randall_Brown]
 * 
 * 	Removed Pelican code
 * 	[92/08/21  10:33:08  Randall_Brown]
 * 
 * Revision 1.1.3.18  92/08/20  12:54:42  Peter_Schulter
 * 	Code cleanup: Changed Ruby to DEC7000 and Cobra to DEC4000.
 * 	[92/08/20  10:22:20  Peter_Schulter]
 * 
 * Revision 1.1.3.17  92/08/10  10:44:42  Peter_Schulter
 * 	Changed name of SIOP driver to siopco.
 * 	[92/08/06  10:29:52  Peter_Schulter]
 * 
 * Revision 1.1.3.16  92/07/17  15:33:03  Ronald_Hegli
 * 	Added XZA/SCSI support, now that we're using
 * 	the generalized SIM xpt and sched layers.
 * 	[92/07/17  15:22:53  Ronald_Hegli]
 * 
 * Revision 1.1.3.15  92/07/09  10:05:45  Randall_Brown
 * 	Cleanup of ALPHA_FLAMINGO and #ifdef OSFPAL
 * 	[92/07/08  10:40:41  Randall_Brown]
 * 
 * Revision 1.1.3.14  92/06/25  17:50:47  Peter_Schulter
 * 	merged in Silver BL8
 * 	Revision 1.1.3.4  92/06/02  11:22:26  cam_proj_Janet_Schank
 * 	Added call to simsii_enable_interrupts for DS_3100
 * 	[92/05/27  12:23:14  Janet_Schank]
 * 
 * 	Moved CAM include files from sys to io/cam
 * 	[92/05/13  08:27:05  Janet_Schank]
 * 
 * Revision 1.1.3.13  92/06/16  16:42:50  Farrell_Woods
 * 	Add code to avoid confusion between tcds and asc interrupt
 * 	handlers.  Print message if asc is found where tcds is
 * 	expected and vice-versa.  Remove call to flamingo_set_ioslot
 * 	to turn on map registers; moved it into DME.
 * 	[92/06/16  16:35:09  Farrell_Woods]
 * 
 * Revision 1.1.3.12  92/06/01  14:16:00  Farrell_Woods
 * 	Add support for PMAZ-AA on Alpha.  Put in hooks for
 * 	PMAZ-DS support on Mips boxes.
 * 	[92/06/01  12:21:44  Farrell_Woods]
 * 
 * Revision 1.1.3.11  92/04/20  14:02:41  Farrell_Woods
 * 	Get rid of bogus pointer manipulation for Flamingo now
 * 	that the base address for the slot is passed up.
 * 	[92/04/20  13:47:22  Farrell_Woods]
 * 
 * Revision 1.1.3.10  92/04/14  15:28:22  Peter_Schulter
 * 	merged in Silver BL5
 * 	Revision 1.1.5.2  92/03/06  14:50:02  William_Dallas
 * 	Added KZQSA support
 * 	[92/03/06  14:32:46  William_Dallas]
 * 
 * Revision 1.1.3.9  92/04/09  13:58:00  Farrell_Woods
 * 	Bracket Flamingo and Cobra specific stuff with
 * 	an ifdef __alpha
 * 	[92/04/09  13:57:02  Farrell_Woods]
 * 
 * Revision 1.1.3.8  92/04/07  15:43:52  Farrell_Woods
 * 	Cleanup 1.1.3.3 changes for TSCSI support.
 * 	[92/04/07  15:00:32  Farrell_Woods]
 * 
 * Revision 1.1.3.7  92/04/01  19:01:39  Peter_Schulter
 * 	Added interfaces to Cobra SCSI driver (SIOP).
 * 	[92/04/01  19:00:01  Peter_Schulter]
 * 
 * Revision 1.1.3.6  92/03/31  10:37:32  Farrell_Woods
 * 	Change name of internal SCSI option to PMAZ-DS.
 * 	[92/03/31  10:36:02  Farrell_Woods]
 * 
 * Revision 1.1.3.5  92/03/25  11:32:02  Farrell_Woods
 * 	get rid of compiler warning about extra #endif
 * 	[92/03/25  11:31:22  Farrell_Woods]
 * 
 * Revision 1.1.3.4  92/03/23  15:47:09  Farrell_Woods
 * 	Fix merge botch
 * 	[92/03/23  15:46:38  Farrell_Woods]
 * 
 * Revision 1.1.3.3  92/03/23  10:47:18  Farrell_Woods
 * 	Implement changes for Flamingo support
 * 	[92/03/20  17:23:00  Farrell_Woods]
 * 
 * 	foo
 * 	[92/03/20  17:16:52  Farrell_Woods]
 * 
 * Revision 1.1.3.2  92/03/18  13:46:21  Al_Delorey
 * 	From Silver: AG_BL5
 * 	[92/03/18  12:25:53  Al_Delorey]
 * 
 * 	Added include of <mach/vm_param.h> for Alpha.
 * 	[92/02/21  13:33:15  Janet_Schank]
 * 
 * 	Made 64bit modifications
 * 	[92/01/31  09:55:34  Janet_Schank]
 * 
 * 	Merged in changes from LA.
 * 	[92/01/28  18:08:29  Janet_Schank]
 * 
 * 	CAM support added
 * 	[92/01/17  11:18:30  Janet_Schank]
 * 
 * Revision 1.1.1.2  92/03/17  15:11:25  devbld_gsf
 * 	First AG_BL5 version.  Moved from Ag baselevel delivery tree.
 * 
 * $EndLog$
 */
#pragma ident "@(#)$RCSfile: sim_config.c,v $ $Revision: 1.1.82.2 $ (DEC) $Date: 1997/01/10 00:26:39 $"

/************************************************************************
 *
 * File:	sim_config.c
 * Date:	June 17, 1991
 * Author:	Robert P. Scott
 *
 * Description:
 *	CAM peripheral driver configuration information.
 *
 * Modification History:
 *
 *	91/07/03	rps	Changed TC option names to match std.
 *
 *	91/07/20	rps	Added spurious interrupt handling code.
 *
 * 	91/09/09	rps	Added temp. MAXINE/BIGMAX support.
 *
 *	91/09/26	rps	Needed check for turbo channel exist.
 *
 *	91/10/22	janet
 *	o Removed "#ifndef GENERIC" ifdefs.
 *	o Modified sim_enable_interrupts to take SIM_SOFTC pointer
 *	  as an argument.  Added "#ifdef (DS5000 | DS5000_100)" around
 *	  call to tc_enable_option().
 *
 *	91/10/24	janet
 *	Added Mipsmate support.
 *
 *	91/10/25	janet
 *	Added default configuration functins: hba_default_probe(),
 *	hba_default_attach(), hba_default_chip_reset(), dme_default_attach(),
 *	dme_default_unload().
 *
 *	91/11/15	jag
 *	Made the changes from LARRY to the LR specific defines.
 */

#include <io/common/iotypes.h>
#include <sys/types.h>			/* system level types */
#include <sys/param.h>			/* system level parameter defs */
#include <sys/buf.h>
#include <sys/time.h>
#include <kern/lock.h>
#include <io/cam/dec_cam.h>
#include <mach/vm_param.h>
#include <io/cam/cam.h>
#include <io/cam/scsi_all.h>
#include <hal/cpuconf.h>
#include <io/dec/tc/tc.h>
#include <io/cam/cam_config.h>
#include <io/cam/sim_config.h>
#include <io/cam/cam_debug.h>
#include <io/cam/sim_target.h>
#include <io/cam/sim_cirq.h>
#include <io/cam/dme.h>
#include <io/cam/sim.h>
#include <io/cam/sim_common.h>
#include <io/cam/sim_94.h>
#include <io/cam/scsi_status.h>
#include <io/cam/dme_tcds_94_dma.h>
#include <io/common/devdriver.h>

#include "ata.h"
#include "asc.h"
#include "tcds.h"
#include "tza.h"
#include "pza.h"
#include "isp.h"
#include "simos.h"

#include "siop.h"
#include "psiop.h"
#include "aha.h"
#include "xza.h"

/* ---------------------------------------------------------------------- */
/* Local defines.
 */

extern int cpu;
extern SIM_SOFTC *softc_directory[];

#if NASC > 0 || NTCDS > 0
extern sim94_probe(), sim94_attach(), sim94_unload();
extern sim_kn02_chip_reset(), sim_kn02ba_chip_reset();
extern sim_fast_chip_reset(), simfast_attach();

extern ram94_dme_attach(), ram94_dme_unload();
extern tcds_dme_attach(), tcds_dme_unload();
#endif

#if NATA > 0
extern ata_probe(), ata_attach(), ata_unload();
extern ata_reset();
extern ata_dme_attach(), ata_dme_unload();
#endif

#if NTZA > 0
extern kztsa_probe(), kztsa_attach(), kztsa_unload();
extern kztsa_reset();
extern kztsa_dme_attach(), kztsa_dme_unload();
#endif

#if NPZA > 0
extern pza_probe(), pza_attach(), pza_unload();
extern pza_adap_reset();
extern pza_dme_attach(), pza_dme_unload();
#endif
                                 
#if NPSIOP > 0
extern psiop_probe(), psiop_pci_attach(), psiop_unload(), psiop_chip_reset();
#endif	/* NPSIOP > 0 */

#if NISP > 0
extern isp_probe(), isp_attach(), isp_unload(), isp_chip_reset();
#endif /* NISP > 0 */

#if NSIMOS > 0
extern simos_probe(), simos_attach(), simos_unload(), simos_chip_reset();
#endif /* NSIMOS >0 */

#if NSIOP > 0
extern siop_probe(), siop_kn430_attach(), siop_unload(), siop_chip_reset();
#endif	/* NSIOP > 0 */

#if NAHA > 0
extern aha_probe(), aha_attach(), aha_unload(), aha_chip_reset();
#endif  /* NAHA > 0 */

#if NXZA > 0
extern skz_probe(), skz_attach(), skz_reset_attach(), skz_unload();
#else
void xza_enable_intr() {}
#endif /* NXZA > 0 */

extern dme_null_attach(), dme_null_null();

/* Default config functions */
int hba_default_probe(), hba_default_attach(), hba_default_chip_reset(),
    dme_default_attach(), dme_default_unload();


int cam_hba_limit = INIT_CAM_HBA_LIMIT;
int cam_dme_limit = INIT_CAM_DME_LIMIT;

CAM_HBA_LIST_ENTRY           cam_hba_list[INIT_CAM_HBA_LIMIT+1];
CAM_DME_LIST_ENTRY           cam_dme_list[INIT_CAM_DME_LIMIT+1];

int cam_hba_entries = 0;
int cam_dme_entries = 0;

static int config_init = 0;        /* remove this or do it right */

void
init_sim_components( void )
{
    int i;

    if ( config_init != 4192 )           /* init these structs on first */
      {                                  /* time through only */
	for( i=0; i<cam_hba_limit; i++ )
	  {
	    cam_hba_list[i].cs_name = (char *) NULL;
	    cam_hba_list[i].cs_probe = NULL;
	    cam_hba_list[i].cs_unload = NULL;
	  }
	cam_hba_entries = 0;
	
	for( i=0; i<cam_dme_limit; i++ )
	  {
	    cam_dme_list[i].dme_name = (char *) NULL;
	    cam_dme_list[i].dme_init = NULL;
	    cam_dme_list[i].dme_unload = NULL;
	  }
	cam_dme_entries = 0;
	
#if NASC > 0 || NTCDS > 0
    add_cam_hba_entry( "asc", sim94_probe, sim94_attach, sim_kn02_chip_reset, 
		      sim94_unload );
    add_cam_hba_entry( "PMAZ-AA ", sim94_probe, sim94_attach, 
		      sim_kn02_chip_reset, sim94_unload );
    add_cam_hba_entry( "PMAZ-DS ", sim94_probe, sim94_attach, 
		      sim_kn02ba_chip_reset, sim94_unload );
    add_cam_hba_entry( "PMAZ-FS ", sim94_probe, simfast_attach, 
		      sim_fast_chip_reset, sim94_unload );
    add_cam_hba_entry( "PMAZB-AA", sim94_probe, sim94_attach, 
		      sim_kn02ba_chip_reset, sim94_unload );
    add_cam_hba_entry( "PMAZC-AA", sim94_probe, simfast_attach, 
		      sim_fast_chip_reset, sim94_unload );

    add_cam_dme_entry( "ram94", ram94_dme_attach, ram94_dme_unload );
    add_cam_dme_entry( "PMAZ-DS ", tcds_dme_attach, tcds_dme_unload );
    add_cam_dme_entry( "PMAZ-FS ", tcds_dme_attach, tcds_dme_unload );
    add_cam_dme_entry( "PMAZB-AA", tcds_dme_attach, tcds_dme_unload );
    add_cam_dme_entry( "PMAZC-AA", tcds_dme_attach, tcds_dme_unload );
    add_cam_dme_entry( "PMAZ-AA ", ram94_dme_attach, ram94_dme_unload );

#endif /* NASC || NTCDS */

#if NTZA > 0
    add_cam_hba_entry( "KZTSA-AA", kztsa_probe, kztsa_attach,
                      kztsa_reset, kztsa_unload );
    add_cam_dme_entry( "KZTSA-AA", kztsa_dme_attach, kztsa_dme_unload );
#endif /* NTZA */
                       
#if NPZA > 0
    add_cam_hba_entry( "pza", pza_probe, pza_attach,
                       pza_adap_reset, pza_unload );
    add_cam_dme_entry( "pza", pza_dme_attach, pza_dme_unload );
#endif /* NPZA */

#if NPSIOP > 0
    add_cam_hba_entry( "psiop", psiop_probe, psiop_pci_attach,
			psiop_chip_reset, psiop_unload );
#endif /* NPSIOP > 0 */

#if NISP > 0
    add_cam_hba_entry( "isp", isp_probe, isp_attach,
			isp_chip_reset, isp_unload );
#endif /* NISP > 0 */

#if NSIMOS > 0 
    add_cam_hba_entry("simos",simos_probe, simos_attach,
        simos_chip_reset, simos_unload );
#endif /* NSIMOS > 0 */

#if NSIOP > 0
    add_cam_hba_entry("siopco",siop_probe, siop_kn430_attach,
			siop_chip_reset, siop_unload);
#endif /* NSIOP > 0 */

#if NAHA > 0
    add_cam_hba_entry("aha",aha_probe, aha_attach,
			aha_chip_reset, aha_unload);
#endif /* NAHA > 0 */

#if NATA > 0
    add_cam_hba_entry( "ata", ata_probe, ata_attach, 
		      ata_reset, ata_unload );
    add_cam_dme_entry( "ata", ata_dme_attach, ata_dme_unload );
#endif

#if NXZA > 0
    add_cam_hba_entry ( "xza", skz_probe, skz_attach,
			skz_reset_attach, skz_unload );
#endif /* NXZA > 0 */

    add_cam_dme_entry("null", dme_null_attach, dme_null_null);

    /*
     * Default entries.
     */
    add_cam_hba_entry( "hba_default", hba_default_probe, hba_default_attach,
		       hba_default_chip_reset);
    add_cam_dme_entry( "dme_default", dme_default_attach, dme_default_unload);
    

      }

    config_init = 4192;              /* so we don't go through again */
}

int
add_cam_hba_entry( char *name, int (*probe)(), int (*attach)(),
		  int (*reset_attach)(), int (*unload)() )
{
    int i;

    if ( cam_hba_entries == cam_hba_limit )
      {
        PRINTD( NOBTL, NOBTL, NOBTL, CAMD_INOUT, 
	       ("[b/t/l] (add_cam_hba_entry) Count = %d, cannot yet expand list.\n" ));
	return CAM_REQ_CMP_ERR;
      }

    for( i=0; i<cam_hba_entries && cam_hba_list[i].cs_name &&
	strcmp( name, cam_hba_list[i].cs_name );
	i++ )
      {}

    if ( i < cam_hba_entries )   /* we didn't hit the end of the list? */
      {
	PRINTD( NOBTL, NOBTL, NOBTL, CAMD_INOUT, 
	       ("[b/t/l] (add_cam_hba_entry) duplicate entry '%s'\n", name ));
	return CAM_REQ_CMP_ERR;
      }

    cam_hba_list[cam_hba_entries].cs_name = name;
    cam_hba_list[cam_hba_entries].cs_probe = probe;
    cam_hba_list[cam_hba_entries].cs_attach = attach;
    cam_hba_list[cam_hba_entries].cs_reset_attach = reset_attach;
    cam_hba_list[cam_hba_entries].cs_unload = unload;

    cam_hba_entries++;
    return CAM_REQ_CMP;
}

int 
remove_cam_hba_entry( char *name )
{
    int i;

    for( i=0; i<cam_hba_entries && cam_hba_list[i].cs_name && 
	strcmp( name, cam_hba_list[i].cs_name );
	i++ )
      {}

    if ( i == cam_hba_entries )          /* we hit the end of the list? */
        return CAM_REQ_CMP_ERR;

    while( i < cam_hba_entries )
      {
	cam_hba_list[i].cs_name = 
            cam_hba_list[i+1].cs_name;
	cam_hba_list[i].cs_probe = 
            cam_hba_list[i+1].cs_probe;
	cam_hba_list[i].cs_unload = 
            cam_hba_list[i+1].cs_unload;
	
	i++;
      }

    cam_hba_list[i].cs_name = (char *) NULL;
    cam_hba_list[i].cs_probe = NULL;
    cam_hba_list[i].cs_unload = NULL;

    cam_hba_entries--;
    return CAM_REQ_CMP;
}

int
name_lookup_hba_probe(name, ba, prb)
char *name;
char *ba;
struct controller *prb;
{
  int i;

  for( i=0; i<cam_hba_entries && cam_hba_list[i].cs_name &&
      strcmp( name, cam_hba_list[i].cs_name );
      i++ )
    {}

  if ( i == cam_hba_entries )
    {
      PRINTD( NOBTL, NOBTL, NOBTL, CAMD_INOUT,
	     ("[b/t/l] (name_lookup_hba_probe) name '%s' not found.\n", name ) );
      return CAM_REQ_CMP_ERR;
    }

  return cam_hba_list[i].cs_probe( ba, prb );
}

int
name_lookup_hba_attach( char *name, SIM_SOFTC *sc )
{
  int i;

    PRINTD( NOBTL,NOBTL,NOBTL,CAMD_INOUT,
	   ("[b/t/l] (name_lookup_hba_attach) entry - name='%s', sc=0x%x \n", 
	    name, sc ) );

  for( i=0; i<cam_hba_entries && cam_hba_list[i].cs_name &&
      strcmp( name, cam_hba_list[i].cs_name );
      i++ )
    {}

  if ( i == cam_hba_entries )
    {
      PRINTD( NOBTL, NOBTL, NOBTL, CAMD_INOUT,
	     ("[b/t/l] (name_lookup_hba_attach) name '%s' not found.\n", name ) );
      return CAM_REQ_CMP_ERR;
    }

  return cam_hba_list[i].cs_attach( sc );
}

unsigned long
name_lookup_hba_reset_attach( char *name, SIM_SOFTC *sc )
{
  int i;

    PRINTD( NOBTL,NOBTL,NOBTL,CAMD_INOUT,
	   ("[b/t/l] (name_lookup_hba_reset_attach) entry - name='%s', sc=0x%x \n", 
	    name, sc ) );

  for( i=0; i<cam_hba_entries && cam_hba_list[i].cs_name &&
      strcmp( name, cam_hba_list[i].cs_name );
      i++ )
    {}

  if ( i == cam_hba_entries )
    {
      PRINTD( NOBTL, NOBTL, NOBTL, CAMD_INOUT,
	     ("[b/t/l] (name_lookup_hba_reset_attach) name '%s' not found.\n", name ) );
      return CAM_REQ_CMP_ERR;
    }

  return (unsigned long) cam_hba_list[i].cs_reset_attach;
}


int
add_cam_dme_entry( char *name, int (*init)(), int (*unload)() )
{
    int i;

    if ( cam_dme_entries == cam_dme_limit )
      {
        PRINTD( NOBTL, NOBTL, NOBTL, CAMD_INOUT, 
	       ("[b/t/l] (add_cam_dme_entry) Count = %d, cannot yet expand list.\n" ) );
	return CAM_REQ_CMP_ERR;
      }
    
    for( i=0; i<cam_dme_entries && cam_dme_list[i].dme_name &&
        strcmp( name, cam_dme_list[i].dme_name );
        i++ )
      {}

    if ( i < cam_dme_entries )
      {
	PRINTD( NOBTL, NOBTL, NOBTL, CAMD_INOUT, 
	       ("[b/t/l] (add_cam_dme_entry) duplicate name '%s'\n", name ) );
        return CAM_REQ_CMP_ERR;
      }

    cam_dme_list[cam_dme_entries].dme_name = name;
    cam_dme_list[cam_dme_entries].dme_init = init;
    cam_dme_list[cam_dme_entries].dme_unload = unload;

    cam_dme_entries++;
    return CAM_REQ_CMP;
}

int 
remove_cam_dme_list( char *name )
{
    int i;

    for( i=0; i<cam_dme_entries &&  cam_dme_list[i].dme_name &&
	strcmp( name, cam_dme_list[i].dme_name );
	i++ )
      {}

    if ( i == cam_dme_entries )          /* we hit the end of the list? */
        return CAM_REQ_CMP_ERR;

    while( i < cam_dme_entries )
      {
	cam_dme_list[i].dme_name = 
            cam_dme_list[i+1].dme_name;
	cam_dme_list[i].dme_init = 
            cam_dme_list[i+1].dme_init;
	cam_dme_list[i].dme_unload = 
            cam_dme_list[i+1].dme_unload;
	
	i++;
      }

    cam_dme_list[i].dme_name = (char *) NULL;
    cam_dme_list[i].dme_init = NULL;
    cam_dme_list[i].dme_unload = NULL;

    cam_dme_entries--;
    return CAM_REQ_CMP;
}

int
name_lookup_dme_init( char *name, SIM_SOFTC *sc )
{
  int i;

    PRINTD( NOBTL,NOBTL,NOBTL,CAMD_INOUT,
	   ("[b/t/l] (name_lookup_dme_init) entry - name='%s', sc=0x%x \n", 
	    name, sc ) );

  for( i=0; i<cam_dme_entries && cam_dme_list[i].dme_name &&
      strcmp( name, cam_dme_list[i].dme_name );
      i++ )
    {}

  if ( i == cam_dme_entries )
    {
      PRINTD( NOBTL, NOBTL, NOBTL, CAMD_INOUT,
	     ("[b/t/l] (name_lookup_dme_init) name '%s' not found.\n", name ) );
      return CAM_REQ_CMP_ERR;
    }

  return cam_dme_list[i].dme_init( sc );
}

int
hba_dme_attach( U32 pathid, SIM_SOFTC *sc )
{
    int retval = CAM_REQ_CMP;
    char *hbaname, *dmename;            /* used in config process */
    char modname[32];                   /* TC module name - what size? -RPS */
    caddr_t csr;			/* CSR addess from softc struct */
    unsigned long tpt;

    PRINTD( NOBTL,NOBTL,NOBTL,CAMD_INOUT,
	   ("[b/t/l] (hba_dme_attach) entry - pathid=%d, sc=0x%x \n", pathid, sc ) );

    csr = sc->csr_probe;		/* get what was stored by probe */

    switch( cpu )
        {
	case DEC_3000_500:
	case DEC_3000_300:
	    if( tc_addr_to_name( csr, modname ) == -1)
	      PRINTD( NOBTL, NOBTL, NOBTL, CAMD_INOUT, 
		     ("[b/t/l] (hba_dme_attach) tc_addr_to_name failed ") );
	    hbaname = modname;
	    dmename = modname;
	    break;

	case DEC_4000:
	    hbaname = "siopco";
	    dmename = "null";
	    break;

        default:
	    /* 
	     * Get our controller name and compare it
	     */
	    if(strcmp(((struct controller *)sc->um_probe)->bus_name, 
			    "psiop") == NULL)
	    { 
		hbaname = "psiop";
		dmename = "null";
	    }
	    else if(strcmp(((struct controller *)sc->um_probe)->bus_name, 
			    "aha") == NULL)
	    {
		hbaname = "aha";
		dmename = "null";
	    }
	    else if(strcmp(((struct controller *)sc->um_probe)->bus_name, 
			   "pza") == NULL)
	    {
		hbaname = "pza";
		dmename = "null";
	    }
	    else if(strcmp(((struct controller *)sc->um_probe)->bus_name, 
                            "isp") == NULL)
            {
                hbaname = "isp";
                dmename = "null";
            } 
            else if (strcmp(((struct controller *)sc->um_probe)->bus_name, 
			      "simos") == NULL)
	    {
                hbaname = "simos";
                dmename = "null";
	    }
	    else if(strcmp(((struct controller *)sc->um_probe)->bus_name, 
                            "xza") == NULL)
            {
                hbaname = "xza";
                dmename = "null";
            }
	    else if(strcmp(((struct controller *)sc->um_probe)->bus_name, 
                            "ata") == NULL)
            {
                hbaname = "ata";
                dmename = "ata";
            }
	    else 
            {
		 hbaname = "hba_default";
		 dmename = "dme_default";
	    }
            break;
	}

    /*
     * First perform the attach function which will link the SIM XPT to the
     * underlying SIM HBA's and DME's. The softc for this HBA is setup to
     * allow further initialization of the CAM subsystem.
     */
    if ( name_lookup_hba_attach( hbaname, sc ) != CAM_REQ_CMP )
        {
	/* 
	 * If the attach fails don't do any further initialization.
	 */
	printf("hba_dme_attach: (%d/n/n) - hba '%s' attach failed.\n", 
	       pathid, hbaname );
	retval = CAM_REQ_CMP_ERR;
        }
    else
    {
	tpt = name_lookup_hba_reset_attach( hbaname, sc );
	if ( tpt != CAM_REQ_CMP_ERR )
	{
	    sc->hba_chip_reset = (void *) tpt;
	}
	else
	{
	    printf("hba_dme_attach: (%d/n/n) - reset attach of '%s' failed.\n",
		   pathid, hbaname );
	}
    }

    if ( name_lookup_dme_init( dmename, sc ) != CAM_REQ_CMP )
	{
	printf("hba_dme_attach: (%d/n/n) - dme '%s' attach failed.\n",
	       pathid, dmename );
	retval = CAM_REQ_CMP_ERR;
	}

    return retval;
}

sim_enable_interrupts(sc)
SIM_SOFTC *sc;
{
    struct controller attach;	/* used by tc_enable_option */
    struct controller *prb = (struct controller *)sc->um_probe;
    char adapt[30];

    (&attach)->tcindx = prb->tcindx; /* used by tc_enable_option */

    if ((strncmp(prb->bus_name, "tc", 2) == 0) || 
	(strncmp(prb->bus_name, "tza", 3) == 0) || 
	(strncmp(prb->bus_name, "asc", 3) == 0)) {
	/*
	 * CPU doesn't matter in this case, if it's on a tc (or tcds)
	 * then we must enable the tc slot for interrupts.
	 */
	tc_enable_option( &attach );
    }

    switch( cpu )
    {

    default:
	break;
	
    }
}

hba_default_probe()
{
    printf("HBA Probe: Unable to determine SCSI host bus adapter type!\n");
    return(0);
}
hba_default_attach()
{
    printf("HBA Attach: Unable to determine SCSI host bus adapter type!\n");
}
hba_default_chip_reset()
{
    printf("HBA Chip Reset: Unable to determine SCSI host bus adapter type!\n");
}
dme_default_attach()
{
    printf("DME Attach: Unable to determine SCSI host bus adapter type!\n");
}
dme_default_unload()
{
    printf("DME Unload: Unable to determine SCSI host bus adapter type!\n");
}
